Module Bin_Mod

    Public Table_Location As String
    Public Multiplier As Single
    Public Row_Count As Integer
    Public Column_Count As Integer

    Dim GotIt As Boolean = False




    Public Function Get_OSID(ByVal File_Name As String) As String

        Dim fs As New IO.FileStream(File_Name, IO.FileMode.Open, IO.FileAccess.Read)
        Dim r As New IO.BinaryReader(fs)
        Dim mFile_Info As New IO.FileInfo(File_Name)

        Dim OSID As String = ""

        Dim OSID_String1 As String = ""
        Dim OSID_String2 As String = ""
        Dim Use_OSID As String = ""
        Dim tmpBinaryValue As String = ""

        Dim CellValue As String = ""
        Dim i As Integer = 0
        Dim c1 As Integer
        Dim c2 As Integer

        For i = 0 To mFile_Info.Length - 1

            tmpBinaryValue = CellValue
            CellValue = Hex(r.ReadByte)

            If CellValue.Length < 2 Then
                CellValue = "0" & CellValue
            End If

            tmpBinaryValue += CellValue

            If i > (mFile_Info.Length - 6) And c1 < 3 Then
                OSID_String1 += CellValue
                c1 += 1
            End If
            If i > (mFile_Info.Length - 8) And c2 < 3 Then
                OSID_String2 += CellValue
                c2 += 1
            End If
        Next

        fs.Close()
        r.Close()

        If tmpBinaryValue = "FFFF" Then
            Return Convert.ToInt32(OSID_String2, 16)
        Else
            Return Convert.ToInt32(OSID_String1, 16)
        End If

    End Function

    Public Function Auto_Fill_Tables(ByVal Binary_Path As String) As Boolean


        MAFLoaded = Fill_MAF_Table(Binary_Path)

        VELoaded = Fill_VE_Table(Binary_Path)

        TimingTableImported= Fill_GFS_Table(Binary_Path)

        If MAFLoaded = False And VELoaded = False And TimingTableImported = False Then
            MessageBox.Show("The tables for this PCM have not been added to this program." & vbCrLf & vbCrLf & _
                            "Please import the tables using the csv files exported from PowrTuner.", "PCM not in file", MessageBoxButtons.OK, MessageBoxIcon.Information)
        End If

    End Function
    Public Function ImportBinaryFile(ByVal File_Name As String) As Boolean

        Dim fs As New IO.FileStream(File_Name, IO.FileMode.Open, IO.FileAccess.Read)
        Dim r As New IO.BinaryReader(fs)
        Dim File_Info As New IO.FileInfo(File_Name)

        BinaryFileLoaded = False
        ReDim BinaryFile(File_Info.Length - 1)

        Dim retval As Boolean = True
        Try
            Dim i As Integer
            For i = 0 To File_Info.Length - 1
                BinaryFile(i) = r.ReadByte
            Next
        Catch ex As Exception
            retval = False
            MsgBox(ex.Message)
        End Try

        Return retval


    End Function

    Private Function Fill_MAF_Table(ByVal Source_File As String) As Boolean

        Dim MAFTableImported As Boolean = False

        If Get_MAF_Table_Info(Current_OSID) Then  'Returns True if MAF table info was found

            Dim i As Long    'counter
            Dim tmpString As String 'Multiuse string holder
            Dim bStartPos As Integer = Convert.ToInt32(Table_Location, 16)

            'Table_Location = "6EE30"
            'Multiplier = 0.0078125
            'Row_Count = 81
            'Column_Count = 1

            Dim str1 As String
            Dim sin1 As String
            Dim tmpRowHeader As Integer = 1500
            Dim esCounter As Integer
            Dim tmpHexString As String

            Try
                For i = 0 To Row_Count - 1

                    For esCounter = 1 To 2
                        tmpHexString = Hex(BinaryFile(bStartPos))
                        bStartPos += 1
                        If tmpHexString.Length < 2 Then
                            str1 += "0" & tmpHexString
                        Else
                            str1 += tmpHexString
                        End If
                    Next

                    sin1 = (Convert.ToInt32(str1, 16) * Multiplier)

                    'format the first field, killing the "Hertz " and keeping just the number
                    'the save that and the gm/sec data to the MAFTable array
                    MAFTable(0, i) = tmpRowHeader
                    tmpRowHeader += 125
                    MAFTable(1, i) = sin1

                    sin1 = 0
                    str1 = ""

                Next

                MAFTableImported = True

            Catch ex As Exception
                MsgBox("There was an error importing the MAF table from:" & vbCrLf & _
                    Source_File & vbCrLf & vbCrLf & ex.Message)
                MAFTableImported = False
            End Try

        End If

        Return MAFTableImported

    End Function
    Private Function Fill_VE_Table(ByVal Source_File As String) As Boolean

        Dim VETableImported As Boolean = False

        If Get_VE_Table_Info(Current_OSID) Then

            If Table_Location = "" Then
                Return False
            End If

            Dim i As Long    'counter
            Dim tmpString As String 'Multiuse string holder
            Dim tmpArray As Array   'Use to break up the data from the streamreader

            Dim bStartPos As Integer = Convert.ToInt32(Table_Location, 16)

            Dim str1 As String
            Dim sin1 As String
            Dim esCounter As Integer
            Dim tmpHexString As String

            Try

                Dim a As Integer = 0
                Dim b As Integer = 0

                For i = 0 To (Row_Count * Column_Count)

                    For esCounter = 1 To 2
                        tmpHexString = Hex(BinaryFile(bStartPos))
                        bStartPos += 1
                        If tmpHexString.Length < 2 Then
                            str1 += "0" & tmpHexString
                        Else
                            str1 += tmpHexString
                        End If
                    Next

                    sin1 = (Convert.ToInt32(str1, 16) * Multiplier)


                    'Enter the data to the array
                    If a < 17 Then VETable(a, b) = sin1

                    sin1 = 0
                    str1 = ""

                    a += 1
                    If a = Row_Count Then
                        b += 1
                        a = 0
                    End If

                Next

                VETableImported = True

            Catch ex As Exception
                MsgBox("There was an error importing the VE table from:" & vbCrLf & _
                        Source_File & vbCrLf & vbCrLf & ex.Message)
                VETableImported = False
            End Try

        End If

        Return VETableImported

    End Function
    Private Function Fill_GFS_Table(ByVal Source_File As String, Optional ByVal FillTable4 As Boolean = True) As Boolean

        Dim GFSTableImported As Boolean = False

        If Get_GFS_Table_Info(Current_OSID) Then

            If Table_Location = "" Then
                Return False
            End If

            Dim i As Long    'counter
            Dim tmpString As String 'Multiuse string holder
            Dim tmpArray As Array   'Use to break up the data from the streamreader


            Dim bStartPos As Integer = Convert.ToInt32(Table_Location, 16)


            Dim str1 As String
            Dim sin1 As String
            Dim esCounter As Integer
            Dim tmpHexString As String

            Try

                Dim a As Integer = 0
                Dim b As Integer = 0

                For i = 0 To (Row_Count * Column_Count)

                    For esCounter = 1 To 2
                        tmpHexString = Hex(BinaryFile(bStartPos))
                        bStartPos += 1
                        If tmpHexString.Length < 2 Then
                            str1 += "0" & tmpHexString
                        Else
                            str1 += tmpHexString
                        End If
                    Next

                    If Convert.ToInt32(str1, 16) < 32767 Then
                        sin1 = (Convert.ToInt32(str1, 16) * Multiplier)
                    Else
                        sin1 = ((Convert.ToInt32(tmpString, 16) - 65534) * Multiplier)
                    End If


                    'Enter the data to the array
                    Spark_Data(a, b, 3) = sin1
                    If FillTable4 Then Spark_Data(a, b, 4) = sin1

                    sin1 = 0
                    str1 = ""

                    a += 1
                    If a = 16 Then
                        b += 1
                        a = 0
                    End If

                Next

                GFSTableImported = True

            Catch ex As Exception
                MsgBox("There was an error importing the GFS table from:" & vbCrLf & _
                    Source_File & vbCrLf & vbCrLf & ex.Message)
                GFSTableImported = False
            End Try

        End If

        If Not AddKRData() Then MsgBox("Could not add KR data for spark table")

        Return GFSTableImported

    End Function

    Public Function AdjustBinaryValue(ByVal bValue As Single, Optional ByVal PossibleNegative As Boolean = False) As String

        Dim Factor As Single = Multiplier
        Dim tmpStr As String = ""
        Dim AllowNegative As Boolean = False
        Dim tmpValue As Single = 0.0
        Dim IsNegative As Boolean = False

        tmpValue = bValue

        If tmpValue < 0 Or PossibleNegative Then
            IsNegative = True
        End If

        tmpValue = tmpValue / Factor

        If IsNegative Then
            tmpValue = tmpValue + 65534
        End If

        tmpStr = Hex(tmpValue)

        If tmpStr.Length = 3 Then
            tmpStr = "0" & tmpStr
        ElseIf tmpStr.Length = 2 Then
            tmpStr = "00" & tmpStr
        ElseIf tmpStr.Length = 1 Then
            tmpStr = "000" & tmpStr
        End If

        Return tmpStr

    End Function

    Public Function GenerateChecksum() As String

        Dim Working_OSID As String = Current_OSID

        Dim CRC_Location As Long
        Dim OSID_Location As Long

        Dim retval As String = "00000"

        Dim tmpstr As String = GetParameters(Working_OSID, RT.ret_FlashCRC)
        If tmpstr <> "" Then
            CRC_Location = Convert.ToInt32(tmpstr, 16)
            tmpstr = GetParameters(Working_OSID, RT.ret_OSIDLoc)
            If tmpstr <> "" Then
                OSID_Location = Convert.ToInt32(tmpstr, 16)
            Else
                MsgBox("Can not generate checksum!" & vbCrLf & vbCrLf & _
                                   "Open this file in PowrTuner and then save it." & vbCrLf & _
                                   "Powrtuner will generate the new checksum for the modified file", MsgBoxStyle.Critical)
                Return retval
            End If
        Else
            MsgBox("Can not generate checksum!" & vbCrLf & vbCrLf & _
                   "Open this file in PowrTuner and then save it." & vbCrLf & _
                   "Powrtuner will generate the new checksum for the modified file", MsgBoxStyle.Critical)
            Return retval
        End If

        If CRC_Location = 0 Or OSID_Location = 0 Then
            Return retval
            Exit Function
        End If

        Dim VehicleYear As String = GetParameters(Working_OSID, RT.ret_YearModel)


        '============================================================================

        Dim i As Integer

        Dim Step1Finish As Integer
        Dim Step2Start As Integer
        Dim SkipStep2 As Boolean = False

        If BinaryFile.Length = 1048576 Then
            Step1Finish = 16383
            Step2Start = 65536
        ElseIf BinaryFile.Length = 524288 Then
            Step1Finish = 16383
            Step2Start = 32768
        End If

        If VehicleYear = "1996" Or VehicleYear = "1997" Then
            Step2Start = 16384
        End If


        Dim NewChecksum As Long = 0

        'Step 1
        For i = 0 To Step1Finish Step 2
            NewChecksum += (BinaryFile(i) * 256) + BinaryFile(i + 1)
        Next i

        'Step 2
        If Not SkipStep2 Then
            For i = Step2Start To CRC_Location - 2 Step 2
                NewChecksum += (BinaryFile(i) * 256) + BinaryFile(i + 1)
            Next i
        End If

        'Step 3
        For i = CRC_Location + 4 To OSID_Location - 2 Step 2
            NewChecksum += (BinaryFile(i) * 256) + BinaryFile(i + 1)
        Next i

        'Step 4
        If (OSID_Location + 4) < (BinaryFile.Length - 1) Then
            For i = (OSID_Location + 4) To (BinaryFile.Length - 1) Step 2
                NewChecksum += (BinaryFile(i) * 256) + BinaryFile(i + 1)
            Next i
        End If

        Dim ChecksumHex As String = Hex(NewChecksum)
        If ChecksumHex.Length > 8 Then
            ChecksumHex = ChecksumHex.Remove(0, ChecksumHex.Length - 8)
        End If

        Return ChecksumHex

    End Function
    Public Sub Save_Binary_File()

        Dim retVal As Boolean = True

        Dim Save_Dialog As New SaveFileDialog
        Save_Dialog.Filter = "Binary Files (*.bin)|*.bin"
        Save_Dialog.OverwritePrompt = True
        Save_Dialog.ShowDialog()

        If Save_Dialog.FileName = "" Then Exit Sub

        Dim NewFile As String = Save_Dialog.FileName
        If IO.File.Exists(NewFile) Then
            Try
                IO.File.Delete(NewFile)
            Catch ex As Exception
                MessageBox.Show(ex.Message, "Error Saving", MessageBoxButtons.OK, MessageBoxIcon.Error)
                GoTo Finished
            End Try
        End If

        Dim fs2 As New IO.FileStream(NewFile, IO.FileMode.CreateNew, IO.FileAccess.Write)
        Dim tmpWriter As New IO.BinaryWriter(fs2)

        Try

            Dim i As Integer

            Dim tmpCRC As String = GenerateChecksum()
            If tmpCRC <> "" Then
                Dim CRC_Location As String = Convert.ToInt32(GetParameters(Current_OSID, RT.ret_FlashCRC), 16)

                If tmpCRC.Length > 8 Then tmpCRC = tmpCRC.Substring(tmpCRC.Length - 8, 8)
                BinaryFile(CRC_Location + 0) = Convert.ToInt32(tmpCRC.Substring(0, 2), 16)
                BinaryFile(CRC_Location + 1) = Convert.ToInt32(tmpCRC.Substring(2, 2), 16)
                BinaryFile(CRC_Location + 2) = Convert.ToInt32(tmpCRC.Substring(4, 2), 16)
                BinaryFile(CRC_Location + 3) = Convert.ToInt32(tmpCRC.Substring(6, 2), 16)
            End If

            For i = 0 To BinaryFile.Length - 1
                tmpWriter.Write(BinaryFile(i))
            Next

        Catch ex As Exception
            MessageBox.Show("There was an error saving the new binary file." & vbCrLf & vbCrLf & ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            retVal = False
        End Try

Finished:

        tmpWriter.Close()

        If retVal = True Then MsgBox("Finished saving file.")

    End Sub
End Module
