Imports readINI.ReadINI
Imports System.IO
Imports TinyTuner


Public Class frmTinyTuner

    Dim CloseForm As Boolean = False
    Dim GridChanged As Boolean = False
    Dim BinaryChanged As Boolean = False

    Dim LoadingData As Boolean
    Dim EnableTreeMenu As Boolean = False

    Dim DisplayDescription As Boolean = True  'Used to lock textbox1 when displaying RPMvsSpeed info
    Dim CurrentVIN As String

    Dim CurrentSerial As String
    Dim CurrentTablePath As String = ""

    Private Sub ClearTree()
        TreeView1.Nodes.Clear()
    End Sub

    Private Sub BuildTree()

        TreeView1.Nodes.Clear()

        With TreeView1
            'Setup Main Categories
            .Nodes.Add("Accessories", "Accessories")
            .Nodes.Add("Fuel", "Fuel")
            .Nodes.Add("Spark", "Spark")
            .Nodes.Add("Transmission", "Transmission")
            .Nodes.Add("Supercharger", "Supercharger")
            .Nodes.Add("Torque Management")  'Fuel, Spark, and Transmission
            .Nodes.Add("Diagnostics", "Diagnostics")
            .Nodes.Add("Uncatagorized", "Uncatagorized")

            Dim i As Integer
            Dim CatNode As Integer = 0
            Dim SubCat As String = ""
            Dim SubNode As String = ""

            PopulatepubCategoryList()

            For i = 0 To pubCategoryCount
                CatNode = Val(pubCategoryList(i, 0).Substring(0, 1))
                SubNode = pubCategoryList(i, 1)
                SubCat = SubNode.Replace(" ", "")
                .Nodes(CatNode).Nodes.Add(SubCat, SubNode)
            Next

        End With

    End Sub

    Public Sub LoadAdditionalTables(ByVal useOSID As String)

        LoadingData = True


        'Add the tables to the tree
        Dim intNode1 As Integer = 0
        Dim intNode2 As Integer = 0
        Dim CatCount(7) As Integer

        Me.Text = "Tiny Tuner " & CurrentVersion.tostring & " - Loading available tables - Getting additional information"
        Me.Refresh()

        Dim tmpTableInfo As New TinyTunerDLL.TableLocations
        Dim tmpTableCount As Integer
        Dim tmpTableList As Array

        Dim MapNumber As Int16 = GetMapNumber(useOSID)
        tmpTableCount = tmpTableInfo.GetTableCount(MapNumber)

        Me.Text = "Tiny Tuner " & CurrentVersion.ToString & " - Loading available tables - Sorting table list"
        Me.Refresh()

        tmpTableList = tmpTableInfo.GetTables(Val(MapNumber), True)
        Array.Sort(tmpTableList)

        Dim i As Integer
        Dim a As Integer
        For a = 0 To tmpTableCount

            Me.Text = "Tiny Tuner " & CurrentVersion.ToString & " - Loading available tables - " & a.ToString & " of " & tmpTableCount.ToString
            'Me.Refresh()

            'If i <= tmpTableCount Then ToolStripStatusLabel3.Text = "  Adding table -> " & AvailableTables(TP.Table_Name, i)
            'Me.Refresh()
            'Application.DoEvents()

            For i = 1 To tmpTableCount



                If Not tmpTableList(a) = Nothing And Not AvailableTables(TP.Table_Name, i) = Nothing Then
                    If tmpTableList(a).ToString = AvailableTables(TP.Table_Name, i).ToString Then
                        intNode1 = GetCategory(AvailableTables(TP.Main_Category, i))
                        CatCount(intNode1) += 1
                        If intNode1 < 6 Then
                            intNode2 = GetCategory(AvailableTables(TP.Sub_Category, i), True)
                            TreeView1.Nodes(intNode1).Nodes(intNode2).Nodes.Add(AvailableTables(TP.Table_Name, i))
                        Else
                            TreeView1.Nodes(intNode1).Nodes.Add(AvailableTables(TP.Table_Name, i))
                        End If
                    End If
                End If
            Next
        Next



        'Remove nodes that were not used
        a = 0
        Dim b As Int16 = 0
        Dim c As Int16 = 0
        Dim d As Int16 = 0

        Me.Text = "Tiny Tuner " & CurrentVersion.ToString & " - Loading available tables - Removing blank nodes"
        For i = 0 To 5
            b = TreeView1.Nodes(i).GetNodeCount(False)
            d = 0
            For a = 0 To b - 1

                c = TreeView1.Nodes(i).Nodes(d).GetNodeCount(False)
                If c < 1 Then
                    'MsgBox("Removing " & TreeView1.Nodes(i).Nodes(a).Name)
                    TreeView1.Nodes(i).Nodes(d).Remove()
                    b = TreeView1.Nodes(i).GetNodeCount(False)
                    If b = 0 Then Exit For
                Else
                    d += 1
                End If
            Next

        Next

        LoadingData = False

    End Sub

    Public Sub LoadAdditionalTables_Database(ByVal useOSID As String)

        LoadingData = True


        'Add the tables to the tree
        Dim intNode1 As Integer = 0
        Dim intNode2 As Integer = 0
        Dim CatCount(7) As Integer

        Me.Text = "Tiny Tuner " & CurrentVersion.tostring & " - Loading available tables - Getting additional information"
        Me.Refresh()

        
        Dim MapNumber As Int16 = CurrentMapNumber  'GetMapNumber(useOSID)
        Dim tmpTableCount As Int16 = dsTableData.Tables(0).Rows.Count

        Dim a As Integer
        For a = 0 To tmpTableCount - 1

            Me.Text = "Tiny Tuner " & CurrentVersion.ToString & " - Loading available tables - " & a.ToString & " of " & tmpTableCount.ToString

            Dim tmpString As String
            tmpString = dsTableData.Tables(0).Rows(a).Item("TableName").ToString

            Application.DoEvents()

            intNode1 = GetCategory(dsTableData.Tables(0).Rows(a).Item("MainCategory"))
            CatCount(intNode1) += 1
            If intNode1 < 6 Then
                intNode2 = GetCategory(dsTableData.Tables(0).Rows(a).Item("SubCategory"), True)
                TreeView1.Nodes(intNode1).Nodes(intNode2).Nodes.Add(tmpString)
            Else
                TreeView1.Nodes(intNode1).Nodes.Add(tmpString)
            End If

        Next



        'Remove nodes that were not used
        a = 0
        Dim b As Int16 = 0
        Dim c As Int16 = 0
        Dim d As Int16 = 0
        Dim i As Int16

        Me.Text = "Tiny Tuner " & CurrentVersion.ToString & " - Loading available tables - Removing blank nodes"
        For i = 0 To 5
            b = TreeView1.Nodes(i).GetNodeCount(False)
            d = 0
            For a = 0 To b - 1

                c = TreeView1.Nodes(i).Nodes(d).GetNodeCount(False)
                If c < 1 Then
                    'MsgBox("Removing " & TreeView1.Nodes(i).Nodes(a).Name)
                    TreeView1.Nodes(i).Nodes(d).Remove()
                    b = TreeView1.Nodes(i).GetNodeCount(False)
                    If b = 0 Then Exit For
                Else
                    d += 1
                End If
            Next

        Next

        LoadingData = False

    End Sub

    Private Sub OpenBinaryToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OpenBinaryToolStripMenuItem.Click

        Dim OpenDialog As New OpenFileDialog
        OpenDialog.InitialDirectory = BinaryFolder
        OpenDialog.Filter = "Binary Files (*.bin)|*.bin|All Files (*.*)|*.*"
        OpenDialog.ShowDialog()

        If Not OpenDialog.FileName = "" Then
            LoadFile(OpenDialog.FileName)
        Else
            Me.Text = "Tiny Tuner v" & CurrentVersion.tostring
            BinaryFileLoaded = False
        End If

    End Sub

    Public Sub LoadFile(ByVal FileName As String, Optional ByVal FromRecent As Boolean = False)

        Me.Text = "Tiny Tuner " & CurrentVersion.tostring & " - Loading binary file"
        Me.Refresh()

        DataGridView1.Rows.Clear()
        DataGridView1.Columns.Clear()

        LoadingData = True

        If ImportBinaryFile(FileName) Then

            Me.Text = "Tiny Tuner " & CurrentVersion.tostring & " - Initializing Tables"
            Me.Refresh()

            BinaryFileLoaded = True
            Current_OSID = Get_OSID_From_Loaded()  '(FileName)
            

            If Not UseDatabase Then
                Dim tmpTableInfo As New TinyTunerDLL.TableLocations
                CurrentMapNumber = GetMapNumber(Current_OSID)
                TableCount = tmpTableInfo.GetTableCount(CurrentMapNumber)
                AddToTableToolStripMenuItem.Enabled = False
            Else
                CurrentMapNumber = GetMapNumberFromDatabase(Current_OSID)
                TableCount = GetTableCountFromDatabase(CurrentMapNumber)
                AddToTableToolStripMenuItem.Enabled = True
            End If

            ToolStripStatusLabel2.Text = "OSID: " & Current_OSID.ToString
            ToolStripStatusLabel7.Text = "Template: " & CurrentMapNumber.ToString

            If Not UseDatabase Then ToolStripStatusLabel4.Text = "Table Count: " & TableCount.ToString

            If TableCount = 0 Then
                ToolStripStatusLabel5.Text = ""
                ToolStripStatusLabel6.Text = ""
                ClearTree()
                MessageBox.Show("This file is not supported." & vbCrLf & vbCrLf & "OSID is " & Current_OSID, "OSID Not Supported", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Else

                InitToolsMenu(True)

                LastBinLocation = FileName

                Me.Text = "Tiny Tuner " & CurrentVersion.ToString & " - Retrieving VIN"
                Me.Refresh()
                RetrieveVIN()

                'Loads the tree view list on the left side, and loads the tables
                InitTreeList(CurrentMapNumber)

                If Not FromRecent Then

                    Dim oktoadd As Boolean = VerifyRecentFile(FileName)

                    If SetFolderOnImport Then
                        'check to see if the export path is a UNC path or is on the local machine
                        If FileName.LastIndexOf("\") > 0 Then
                            'local machine
                            BinaryFolder = FileName.Substring(0, FileName.LastIndexOf("\"))
                        Else
                            If FileName.LastIndexOf("/") > 0 Then
                                'Network drive
                                BinaryFolder = FileName.Substring(0, FileName.LastIndexOf("/"))
                            End If
                        End If
                    End If

                    Me.Text = "Tiny Tuner " & CurrentVersion.ToString & " - Setting menus and options"
                    Me.Refresh()

                    If oktoadd Then SetRecentFiles()
                    InitRecentMenu()

                End If

                If Not LinkedBinary = "" Then
                    Me.Text = "Tiny Tuner " & CurrentVersion.ToString & " - Loading control binary"
                    Me.Refresh()
                    If ImportLinkedBinary() Then
                        Dim LastIndex As Int16
                        Dim tmpString As String
                        LastIndex = LinkedBinary.LastIndexOf("\") + 1
                        tmpString = LinkedBinary.Substring(LastIndex, LinkedBinary.Length - LastIndex)
                        LinkBinaryToolStripMenuItem.Text = "Control File - " & tmpString
                    Else
                        LinkBinaryToolStripMenuItem.Text = "Control File - None"
                    End If

                    If LinkedBinaryFileLoaded Then
                        ListDifferencesBetweenFilesToolStripMenuItem.Enabled = True
                    Else
                        ListDifferencesBetweenFilesToolStripMenuItem.Enabled = False
                    End If

                End If
            End If
        End If

        LoadingData = False
        BinaryChanged = False

        Me.Text = "Tiny Tuner " & CurrentVersion.ToString & " - " & FileName

    End Sub

    Private Sub InitTreeList(ByVal CurrentMapNumber As Int16)

        Dim tmpMainFormTitle As String = Me.Text

        Me.Text = "Tiny Tuner " & CurrentVersion.ToString & " - Building table tree"
        Me.Refresh()
        BuildTree()

        Me.Text = "Tiny Tuner " & CurrentVersion.ToString & " - Loading table information"
        Me.Refresh()
        If Not UseDatabase Then
            Dim tmpTableInfo As New TinyTunerDLL.TableLocations
            ReDim AvailableTables(16, TableCount)
            AvailableTables = tmpTableInfo.GetTables(GetMapNumber(Current_OSID), False)
            lblStatusDataLocation.Text = "DLL"
            DatabaseLoaded = False
            ToolStripStatusLabel4.Text = "Table Count: " & tmpTableInfo.GetTableCount(CurrentMapNumber).ToString
        Else
            DatabaseLoaded = FillDataset(CurrentMapNumber)
            If DatabaseLoaded Then
                ToolStripStatusLabel4.Text = "Table Count: " & (dsTableData.Tables(0).Rows.Count - 1).ToString
                lblStatusDataLocation.Text = "DB"
            End If
        End If

        Me.Text = "Tiny Tuner " & CurrentVersion.ToString & " - Loading available tables"
        Me.Refresh()
        If DatabaseLoaded Then
            LoadAdditionalTables_Database(Current_OSID)
        Else
            LoadAdditionalTables(Current_OSID)
        End If

        Me.Text = tmpMainFormTitle

    End Sub
    Private Sub RetrieveVIN()

        Dim tmpVIN As String = ""
        Dim tmpSerial As String = ""
        Dim i As Integer
        Dim VINStart As Integer = 16410   '0401A

        If BinaryFile(VINStart) = 255 Then
            VINStart = 24602
        End If

        If BinaryFile(VINStart) = 255 Then
            tmpVIN = "Invalid VIN"
            ToolsToolStripMenuItem.Enabled = True   'False
        Else
            ToolsToolStripMenuItem.Enabled = True
            For i = VINStart To VINStart + 16
                tmpVIN += Chr(BinaryFile(i))
            Next
        End If

        If tmpVIN = "Invalid VIN" Then
            tmpSerial = "Invalid Serial Number"
            ChangeVINToolStripMenuItem.Enabled = False
            ChangeSerialNumberToolStripMenuItem.Enabled = False
        Else
            Dim SerialStart As Integer = 16398
            For i = SerialStart To SerialStart + 9
                tmpSerial += Chr(BinaryFile(i))  'BinaryFile(i).ToString
            Next
        End If

        ToolStripStatusLabel5.Text = "VIN: " & tmpVIN
        CurrentVIN = tmpVIN
        ToolStripStatusLabel6.Text = "Serial #: " & tmpSerial
        CurrentSerial = tmpSerial

    End Sub

    Private Function GetNodeIndex(ByVal Node_Text As String) As Integer

        Dim retval As Integer = 1000

        Try
            Dim i As Integer
            For i = 0 To TableCount
                If AvailableTables(1, i) = Node_Text Then
                    retval = i
                End If
            Next
        Catch ex As Exception
            retval = 0
        End Try


        Return retval

    End Function

    Private Sub Convert_Data(ByVal List_Index As Integer, Optional ByVal FillWithLinked As Boolean = False)

        If BinaryFileLoaded = False Then Exit Sub

        If List_Index > TableCount Or List_Index = 0 Then Exit Sub

        LoadingData = True
        Dim i As Integer

        DataGridView1.Rows.Clear()
        DataGridView1.Columns.Clear()

        'Table_Name = 1
        'Start_Position = 2
        'Element_Size = 3
        'Factor = 4
        'Units = 5
        'Column_Count = 6
        'Row_Count = 7
        'Row_Header_Step = 8
        'Row_Header_Start = 9
        'AllowNegative = 10
        'Table_Description = 11
        'Table_Column_Headers = 12
        'Table_Row_Headers = 13
        'Main_Category = 14
        'Sub_Category = 15

        If AvailableTables(TP.Start_Position, List_Index).Length < 5 Then Exit Sub

        Dim RoundValues As Boolean = False  'sGetINI(ini_path, "Main", "Round_Values", True)
        Dim DisplayWholeNumbers As Boolean
        If AvailableTables(TP.DisplayWholeNumbers, List_Index).ToUpper = "YES" Then
            DisplayWholeNumbers = True
        Else
            DisplayWholeNumbers = False
        End If

        'Start position - the first 4 characters are the row, the last 1 is the column
        Dim str_Start_Row As String = AvailableTables(TP.Start_Position, List_Index)

        'Number of rows intable
        Dim Row_Count As Integer = Val(AvailableTables(TP.Row_Count, List_Index))
        Dim Column_Count As Integer = Val(AvailableTables(TP.Column_Count, List_Index))

        'Factor - number to multiply the decimal value to in order tp get actual value
        Dim Factor As Single = Val(AvailableTables(TP.Factor, List_Index))

        'Number of bits per cell
        Dim Element_Size As Integer = Val(AvailableTables(TP.Element_Size, List_Index))

        Dim Start_Row As Integer = Convert.ToInt32(str_Start_Row.Substring(0, 4), 16)
        Dim Start_Column_Index As Integer = Convert.ToInt32(str_Start_Row.Substring(4, 1), 16)

        'Used for the tables row headers
        Dim RowHeaderStart As Integer = Val(AvailableTables(TP.Row_Header_Start, List_Index))
        Dim RowHeaderStep As Integer = Val(AvailableTables(TP.Row_Header_Step, List_Index))


        Dim Row_Array() As String = Split(AvailableTables(TP.Table_Row_Headers, List_Index), ",")
        If Row_Array.Length = 3 And Row_Count > 3 Then
            If Row_Array(1) = "by" Then
                Dim _RowInc As Single = Val(Row_Array(2))
                Dim _StartRow As Integer = Val(Row_Array(0))
                ReDim Row_Array(Row_Count)
                For i = 0 To Row_Count
                    Row_Array(i) = Val(_StartRow).ToString
                    _StartRow += _RowInc
                Next
            End If
        End If

        Dim Column_Array() As String = Split(AvailableTables(TP.Table_Column_Headers, List_Index), ",")
        If Column_Array.Length = 3 And Row_Count > 3 Then
            If Row_Array(1) = "by" Then
                Dim _RowInc As Single = Val(Column_Array(2))
                Dim _StartRow As Integer = Val(Column_Array(0))
                ReDim Column_Array(Row_Count)
                For i = 0 To Row_Count
                    Column_Array(i) = Val(_StartRow).ToString
                    _StartRow += _RowInc
                Next
            End If
        End If

        Dim UseHeaderArray As Boolean = False
        If Row_Array.Length >= Row_Count And Column_Array.Length >= Column_Count Then
            UseHeaderArray = True
        End If

        Dim tmpString As String = ""

        Dim Current_Column_Index As Integer = Start_Column_Index
        Dim Current_Row_Index As Integer = Start_Row


        Dim ColCounter As Integer = 0
        Dim b As Integer = RowHeaderStart
        Dim ElementLoop As Integer = 0
        Dim e As New System.Windows.Forms.DataGridViewRow

        Label1.Text = AvailableTables(TP.Table_Name, List_Index)

        For ColCounter = 0 To Column_Count - 1
            DataGridView1.Columns.Add("col" & ColCounter.ToString, "Col " & ColCounter.ToString)
            If UseHeaderArray Then
                DataGridView1.Columns(ColCounter).HeaderText = Column_Array(ColCounter)
            Else
                DataGridView1.Columns(ColCounter).HeaderText = ColCounter.ToString
            End If

            DataGridView1.Columns(ColCounter).Width = 75

        Next


        For i = 0 To Row_Count - 1
            DataGridView1.Rows.Add("row" & i.ToString, "Row " & i.ToString)
            If UseHeaderArray Then
                DataGridView1.Rows(i).HeaderCell.Value = Row_Array(i)
            Else
                DataGridView1.Rows(i).HeaderCell.Value = i.ToString  'b.ToString
            End If
            b += RowHeaderStep
        Next

        If DisplayDescription Then
            TextBox1.WordWrap = True
            TextBox1.Text = AvailableTables(TP.Table_Description, List_Index)
        End If


        DataGridView1.RowHeadersWidthSizeMode = DataGridViewRowHeadersWidthSizeMode.AutoSizeToAllHeaders

        Dim AllowNegatives As Boolean = False

        If Not AvailableTables(TP.AllowNegative, List_Index) = Nothing Then
            If AvailableTables(TP.AllowNegative, List_Index).ToUpper = "NO" Then
                AllowNegatives = False
            Else
                AllowNegatives = True
            End If
        Else
            AllowNegatives = False
        End If

        Dim tmpColPos As Long = 0
        Dim tmpRowPos As Long = 0
        Dim CellPos As String = ""

        Dim str1 As String = ""
        Dim str2 As String = ""
        Dim sin1 As String = ""
        Dim sin2 As String = ""
        Dim esCounter As Integer = 0
        Dim tmpHexString As String = ""
        Dim tmpHexString2 As String = ""

        Dim ToolText As String
        Dim BinDiff As Single

        Dim HexPosition As Long = Convert.ToInt32(str_Start_Row, 16)

        Dim TempValue As Single
        Dim TempValue2 As Single

        For ColCounter = 0 To Column_Count - 1

            For i = 0 To Row_Count - 1

                str1 = ""
                str2 = ""
                sin1 = 0
                sin2 = 0

                For esCounter = 1 To Element_Size
                    tmpHexString = Hex(BinaryFile(HexPosition))
                    If Not LinkedBinary = "" Then tmpHexString2 = Hex(LinkedBinaryFile(HexPosition))
                    HexPosition += 1

                    If tmpHexString.Length < 2 Then
                        str1 += "0" & tmpHexString
                    Else
                        str1 += tmpHexString
                    End If

                    If Not LinkedBinary = "" And tmpHexString2.Length < 2 Then
                        str2 += "0" & tmpHexString2
                    Else
                        str2 += tmpHexString2
                    End If

                Next


                If Convert.ToInt32(str1, 16) > 32767 And AllowNegatives Then
                    sin1 = ((Convert.ToInt32(str1, 16) - 65534) * Factor)
                Else
                    sin1 = (Convert.ToInt32(str1, 16) * Factor)
                End If
                TempValue = Val(sin1)

                If Not LinkedBinary = "" Then
                    If Convert.ToInt32(str2, 16) > 32767 And AllowNegatives Then
                        sin2 = ((Convert.ToInt32(str2, 16) - 65534) * Factor)
                    Else
                        sin2 = (Convert.ToInt32(str2, 16) * Factor)
                    End If
                    TempValue2 = Val(sin2)
                End If


                If DisplayWholeNumbers Then
                    TempValue = Math.Round(TempValue, 0)
                    TempValue = Int(TempValue)
                    If Not LinkedBinary = "" Then
                        TempValue2 = Math.Round(TempValue2, 0)
                        TempValue2 = Int(TempValue2)
                    End If
                End If


                If Not FillWithLinked Then
                    DataGridView1.Rows(i).Cells(ColCounter).Value = TempValue.ToString
                Else
                    If Not LinkedBinary = "" Then  ' 2nd check to verify we have a good linked binary
                        DataGridView1.Rows(i).Cells(ColCounter).Value = TempValue2.ToString
                    Else
                        DataGridView1.Rows(i).Cells(ColCounter).Value = TempValue.ToString
                    End If
                End If


                TempValue = DataGridView1.Rows(i).Cells(ColCounter).Value

                If Not TempValue - TempValue2 = 0 Then
                    If TempValue > 0 Then
                        BinDiff = (TempValue - TempValue2) / TempValue
                    Else
                        BinDiff = (TempValue2 - TempValue) / TempValue2
                    End If

                    BinDiff = Format(BinDiff * 100, "######.###")
                Else
                    BinDiff = 0
                End If

                If LinkedBinaryFileLoaded Then

                    'If Not BinDiff = 0 Then
                    'Debug.Print(TempValue & "  -  " & TempValue2 & "  -  " & BinDiff)
                    'End If

                    ToolText = "Control Value:  " & TempValue2.ToString & vbCrLf & _
                             "Difference of:  " & BinDiff.ToString & "%"

                    If UseGridColors Then
                        DataGridView1.Rows(i).Cells(ColCounter).Style.BackColor = SelectCellColor(BinDiff)
                    End If

                    DataGridView1.Rows(i).Cells(ColCounter).ToolTipText = ToolText
                End If


            Next i

        Next ColCounter


        LoadingData = False
        If Not FillWithLinked Then
            GridChanged = False
        Else
            GridChanged = True
        End If


    End Sub

    
    Private Sub Convert_Data_Database(ByVal TableName As String, ByVal AddToGrid As Boolean, ByVal FillWithLinked As Boolean)

        If BinaryFileLoaded = False Then Exit Sub

        If TableName = "" Then Exit Sub

        Dim List_Index As Int16 = GetIndex(TableName)
        Dim StartColumnIndex As Int16 = 0

        If List_Index < 0 Then Exit Sub

        LoadingData = True
        Dim i As Integer

        DataGridView1.Rows.Clear()
        If Not AddToGrid Then
            DataGridView1.Columns.Clear()
        Else
            StartColumnIndex = DataGridView1.ColumnCount
        End If

        'Dim tmptable As New DataTable("GridData")


        'Table_Name = 1
        'Start_Position = 2
        'Element_Size = 3
        'Factor = 4
        'Units = 5
        'Column_Count = 6
        'Row_Count = 7
        'Row_Header_Step = 8
        'Row_Header_Start = 9
        'AllowNegative = 10
        'Table_Description = 11
        'Table_Column_Headers = 12
        'Table_Row_Headers = 13
        'Main_Category = 14
        'Sub_Category = 15

        If dsTableData.Tables(0).Rows(List_Index).Item("StartPosition").Length < 5 Then Exit Sub

        Dim RoundValues As Boolean = False  'sGetINI(ini_path, "Main", "Round_Values", True)
        Dim DisplayWholeNumbers As Boolean
        If dsTableData.Tables(0).Rows(List_Index).Item("DisplayWholeNumbers") = 1 Then
            DisplayWholeNumbers = True
        Else
            DisplayWholeNumbers = False
        End If

        'Start position - the first 4 characters are the row, the last 1 is the column
        Dim str_Start_Row As String = dsTableData.Tables(0).Rows(List_Index).Item("StartPosition").ToString

        'Number of rows intable
        Dim Row_Count As Integer = Val(dsTableData.Tables(0).Rows(List_Index).Item("RowCount").ToString)
        Dim Column_Count As Integer = Val(dsTableData.Tables(0).Rows(List_Index).Item("ColumnCount"))

        'Factor - number to multiply the decimal value to in order tp get actual value
        Dim Factor As Single = Val(dsTableData.Tables(0).Rows(List_Index).Item("Factor").ToString)

        'Number of bits per cell
        Dim Element_Size As Integer = Val(dsTableData.Tables(0).Rows(List_Index).Item("ElementSize"))

        Dim Start_Row As Integer = Convert.ToInt32(str_Start_Row.Substring(0, 4), 16)
        Dim Start_Column_Index As Integer = Convert.ToInt32(str_Start_Row.Substring(4, 1), 16)

        'Used for the tables row headers - Not used anymore
        Dim RowHeaderStart As Integer = 0  'Val(dsTableData.Tables(0).Rows(List_Index).Item("RowHeaderStart"))
        Dim RowHeaderStep As Integer = 0  'Val(dsTableData.Tables(0).Rows(List_Index).Item("RowHeaderStep"))
        Dim RowHeaderString As String = dsTableData.Tables(0).Rows(List_Index).Item("RowHeaders")

        Dim Row_Array() As String
        Row_Array = Split(RowHeaderString, ",")

        If RowHeaderString.Length > 60 Then
            If RowHeaderString.Replace(" ", "").Substring(0, 56).ToLower = "mg/cyl80,120,160,200,240,280,320,360,400,440,480,520,560" Then
                If HighSparkScale Then
                    Row_Array = Split("Mg/Cyl 80,120,160,200,240,280,320,360,400,440,480,520,560,680,800,920", ",")
                Else
                    Row_Array = Split("Mg/Cyl 80,120,160,200,240,280,320,360,400,440,480,520,560,600,640,680", ",")
                End If
            End If
        ElseIf RowHeaderString.Length > 57 Then
            If RowHeaderString.Replace(" ", "").Substring(0, 45).ToLower = "mg/cyl200,240,280,320,360,400,440,480,520,560" Then
                If HighSparkScale Then
                    Row_Array = Split("Mg/Cyl 200,240,280,320,360,400,440,480,520,560,680,800,920", ",")
                Else
                    Row_Array = Split("Mg/Cyl 200,240,280,320,360,400,440,480,520,560,600,640,680", ",")
                End If
            End If
        End If
        

        If Row_Array.Length = 3 And Row_Count > 3 Then
            If Row_Array(1) = "by" Then
                Dim _RowInc As Single = Val(Row_Array(2))
                Dim _StartRow As Integer = Val(Row_Array(0))
                ReDim Row_Array(Row_Count)
                For i = 0 To Row_Count
                    Row_Array(i) = Val(_StartRow).ToString
                    _StartRow += _RowInc
                Next
            End If
        End If

        Dim Column_Array() As String
        Column_Array = Split(dsTableData.Tables(0).Rows(List_Index).Item("ColumnHeaders"), ",")
        If Column_Array.Length = 3 And Row_Count > 3 Then
            If Row_Array(1) = "by" Then
                Dim _RowInc As Single = Val(Column_Array(2))
                Dim _StartRow As Integer = Val(Column_Array(0))
                ReDim Column_Array(Row_Count)
                For i = 0 To Row_Count
                    Column_Array(i) = Val(_StartRow).ToString
                    _StartRow += _RowInc
                Next
            End If
        End If

        If Column_Count = 1 Then
            If Column_Array(0) = "" Then
                Column_Array(0) = dsTableData.Tables(0).Rows(List_Index).Item("Units").ToString
            End If
        End If

        Dim UseRowHeaderArray As Boolean = False
        Dim UseColHeaderArray As Boolean = False
        If Row_Array.Length >= Row_Count Then
            UseRowHeaderArray = True
        End If

        If Column_Array.Length >= Column_Count Then
            UseColHeaderArray = True
        End If

        Dim tmpString As String = ""

        Dim Current_Column_Index As Integer = Start_Column_Index
        Dim Current_Row_Index As Integer = Start_Row


        Dim ColCounter As Integer = 0
        Dim b As Integer = RowHeaderStart
        Dim ElementLoop As Integer = 0
        Dim e As New System.Windows.Forms.DataGridViewRow

        Label1.Text = dsTableData.Tables(0).Rows(List_Index).Item("TableName")

        'Build datagrid - columns first
        For ColCounter = 0 To Column_Count - 1
            DataGridView1.Columns.Add("col" & (StartColumnIndex + ColCounter).ToString, "Col " & ColCounter.ToString)
            If UseColHeaderArray Then
                DataGridView1.Columns(StartColumnIndex + ColCounter).HeaderText = Column_Array(ColCounter)
            Else
                DataGridView1.Columns(StartColumnIndex + ColCounter).HeaderText = ColCounter.ToString
            End If

            DataGridView1.Columns(StartColumnIndex + ColCounter).Width = 75


        Next

        'Build Datagrid - Then rows
        If StartColumnIndex = 0 Then
            For i = 0 To Row_Count - 1
                DataGridView1.Rows.Add("row" & i.ToString, "Row " & i.ToString)
                If UseRowHeaderArray Then
                    DataGridView1.Rows(i).HeaderCell.Value = Row_Array(i)
                Else
                    DataGridView1.Rows(i).HeaderCell.Value = i.ToString  'b.ToString
                End If
                b += RowHeaderStep
            Next
        End If

        If DisplayDescription Then
            TextBox1.WordWrap = True
            TextBox1.Text = dsTableData.Tables(0).Rows(List_Index).Item("TableDescription")
        End If

        DataGridView1.RowHeadersWidthSizeMode = DataGridViewRowHeadersWidthSizeMode.AutoSizeToAllHeaders


        'GoTo FinishedHere


        Dim AllowNegatives As Boolean = False

        If Not dsTableData.Tables(0).Rows(List_Index).Item("AllowNegative") = Nothing Then
            If dsTableData.Tables(0).Rows(List_Index).Item("AllowNegative") = 0 Then
                AllowNegatives = False
            Else
                AllowNegatives = True
            End If
        Else
            AllowNegatives = False
        End If

        Dim tmpColPos As Long = 0
        Dim tmpRowPos As Long = 0
        Dim CellPos As String = ""

        Dim str1 As String = ""
        Dim str2 As String = ""
        Dim sin1 As String = ""
        Dim sin2 As String = ""
        Dim esCounter As Integer = 0
        Dim tmpHexString As String = ""
        Dim tmpHexString2 As String = ""

        Dim ToolText As String
        Dim BinDiff As Single

        Dim HexPosition As Long = Convert.ToInt32(str_Start_Row, 16)

        Dim TempValue As Single
        Dim TempValue2 As Single

        Dim TableString1 As String = ""
        Dim TableString2 As String = ""

        For ColCounter = 0 To Column_Count - 1

            For i = 0 To Row_Count - 1

                str1 = ""
                str2 = ""
                sin1 = 0
                sin2 = 0

                For esCounter = 1 To Element_Size
                    tmpHexString = Hex(BinaryFile(HexPosition))
                    If Not LinkedBinary = "" Then tmpHexString2 = Hex(LinkedBinaryFile(HexPosition))
                    HexPosition += 1

                    If tmpHexString.Length < 2 Then
                        str1 += "0" & tmpHexString
                    Else
                        str1 += tmpHexString
                    End If

                    If Not LinkedBinary = "" And tmpHexString2.Length < 2 Then
                        str2 += "0" & tmpHexString2
                    Else
                        str2 += tmpHexString2
                    End If

                Next

                If Val(Factor) <> 0 Then
                    If Convert.ToInt32(str1, 16) > 32767 And AllowNegatives Then
                        sin1 = ((Convert.ToInt32(str1, 16) - 65534) * Factor)
                    Else
                        sin1 = (Convert.ToInt32(str1, 16) * Factor)
                    End If

                    TempValue = Val(sin1)

                    If Not LinkedBinary = "" Then
                        If Convert.ToInt32(str2, 16) > 32767 And AllowNegatives Then
                            sin2 = ((Convert.ToInt32(str2, 16) - 65534) * Factor)
                        Else
                            sin2 = (Convert.ToInt32(str2, 16) * Factor)
                        End If
                        TempValue2 = Val(sin2)
                    End If


                    If DisplayWholeNumbers Then
                        TempValue = Math.Round(TempValue, 0)
                        TempValue = Int(TempValue)
                        If Not LinkedBinary = "" Then
                            TempValue2 = Math.Round(TempValue2, 0)
                            TempValue2 = Int(TempValue2)
                        End If
                    End If

                    TableString1 = TempValue.ToString
                    TableString2 = TempValue2.ToString

                Else
                    TableString1 = str1
                    TableString2 = str2
                End If



                If Not FillWithLinked Then
                    DataGridView1.Rows(i).Cells(StartColumnIndex + ColCounter).Value = TableString1
                Else
                    If Not LinkedBinary = "" Then  ' 2nd check to verify we have a good linked binary
                        DataGridView1.Rows(i).Cells(StartColumnIndex + ColCounter).Value = TableString2
                    Else
                        DataGridView1.Rows(i).Cells(StartColumnIndex + ColCounter).Value = TableString1
                    End If
                End If

                If Factor <> 0 Then

                    TempValue = DataGridView1.Rows(i).Cells(StartColumnIndex + ColCounter).Value


                    If Not TempValue - TempValue2 = 0 Then
                        If TempValue > 0 Then
                            BinDiff = (TempValue - TempValue2) / TempValue
                        Else
                            BinDiff = (TempValue2 - TempValue) / TempValue2
                        End If

                        BinDiff = Format(BinDiff * 100, "######.###")
                    Else
                        BinDiff = 0
                    End If

                    If LinkedBinaryFileLoaded Then

                        'If Not BinDiff = 0 Then
                        'Debug.Print(TempValue & "  -  " & TempValue2 & "  -  " & BinDiff)
                        'End If

                        ToolText = "Control Value:  " & TempValue2.ToString & vbCrLf & _
                                 "Difference of:  " & BinDiff.ToString & "%"

                        If UseGridColors Then
                            DataGridView1.Rows(i).Cells(StartColumnIndex + ColCounter).Style.BackColor = SelectCellColor(BinDiff)
                        End If

                        DataGridView1.Rows(i).Cells(StartColumnIndex + ColCounter).ToolTipText = ToolText
                    End If
                End If

            Next i

        Next ColCounter

FinishedHere:

        LoadingData = False
        If Not FillWithLinked Then
            GridChanged = False
        Else
            GridChanged = True
        End If


    End Sub

    
    Private Sub Save_Grid()

        Dim tmpindex As Integer = GetNodeIndex(TreeView1.SelectedNode.Text)

        Dim StartPos As Integer = Convert.ToInt32(AvailableTables(TP.Start_Position, tmpindex), 16)
        Dim Factor As Single = AvailableTables(TP.Factor, tmpindex)

        Dim tmpStr As String = ""
        Dim tmpstr1 As String = ""

        Dim ColCount As Integer = AvailableTables(TP.Row_Count, tmpindex)
        Dim RowCount As Integer = AvailableTables(TP.Column_Count, tmpindex)

        Dim AllowNegative As Boolean
        Dim tmpAllowNegatives As String = AvailableTables(TP.AllowNegative, tmpindex)
        If tmpAllowNegatives = "" Then
            AllowNegative = False
        Else
            If AvailableTables(TP.AllowNegative, tmpindex).ToUpper = "NO" Then
                AllowNegative = False
            Else
                AllowNegative = True
            End If
        End If

        Dim i As Integer = 0
        Dim a As Integer = 0

        Dim tmploop As Integer
        Dim CurrentLength As Integer
        Dim RequiredLength As Integer
        Dim BinaryStringLength As Integer = Val(AvailableTables(TP.Element_Size, tmpindex))

        Dim AddZeroString As String

        Dim tmpLong As Long = 0 '.0
        Dim tmpSingle As Single = 0.0
        Dim tmpDouble As Double
        Dim IsNegative As Boolean = False

        For a = 0 To RowCount - 1
            For i = 0 To ColCount - 1

                tmpSingle = Val(DataGridView1.Item(a, i).Value)

                tmpstr1 = tmpSingle

                tmpSingle = tmpSingle / Factor

                'AllowNegative And 
                If tmpSingle < 0 And BinaryStringLength < 4 Then
                    tmpDouble = tmpSingle + 65534
                ElseIf tmpSingle < 0 And BinaryStringLength > 3 Then
                    tmpDouble = tmpSingle + 4294967295  ' - Val((tmpSingle * -1))  'Val(tmpSingle) + 
                Else
                    tmpDouble = tmpSingle
                End If

                tmpStr = Hex(tmpDouble)


                RequiredLength = BinaryStringLength * 2
                CurrentLength = tmpStr.Length
                AddZeroString = ""
                For tmploop = 1 To RequiredLength - CurrentLength
                    AddZeroString = AddZeroString & "0"
                Next

                tmpStr = AddZeroString & tmpStr

                For tmploop = 0 To BinaryStringLength - 1
                    BinaryFile(StartPos) = Convert.ToInt32(tmpStr.Substring(2 * tmploop, 2), 16)
                    StartPos += 1
                Next

            Next
        Next

        BinaryChanged = True

    End Sub
    Private Sub Save_Grid_Database()

        Dim tmpindex As Integer = GetIndex(TreeView1.SelectedNode.Text)

        Dim StartPos As Integer = Convert.ToInt32(dsTableData.Tables(0).Rows(tmpindex).Item("StartPosition"), 16)
        Dim Factor As Single = dsTableData.Tables(0).Rows(tmpindex).Item("Factor")

        Dim tmpStr As String = ""
        Dim tmpstr1 As String = ""

        Dim ColCount As Integer = dsTableData.Tables(0).Rows(tmpindex).Item("RowCount")
        Dim RowCount As Integer = dsTableData.Tables(0).Rows(tmpindex).Item("ColumnCount")

        Dim AllowNegative As Boolean
        Dim tmpAllowNegatives As String = dsTableData.Tables(0).Rows(tmpindex).Item("AllowNegative")
        If tmpAllowNegatives = "" Then
            AllowNegative = False
        Else
            If tmpAllowNegatives = 0 Then
                AllowNegative = False
            Else
                AllowNegative = True
            End If
        End If


        Dim i As Integer = 0
        Dim a As Integer = 0

        Dim tmploop As Integer
        Dim CurrentLength As Integer
        Dim RequiredLength As Integer
        Dim BinaryStringLength As Integer = Val(dsTableData.Tables(0).Rows(tmpindex).Item("ElementSize"))

        Dim AddZeroString As String

        Dim tmpLong As Long = 0 '.0
        Dim tmpSingle As Single = 0.0
        Dim tmpDouble As Double
        Dim IsNegative As Boolean = False

        For a = 0 To RowCount - 1
            For i = 0 To ColCount - 1

                tmpSingle = Val(DataGridView1.Item(a, i).Value)

                tmpstr1 = tmpSingle

                tmpSingle = tmpSingle / Factor

                'AllowNegative And 
                If tmpSingle < 0 And BinaryStringLength < 4 Then
                    tmpDouble = tmpSingle + 65534
                ElseIf tmpSingle < 0 And BinaryStringLength > 3 Then
                    tmpDouble = tmpSingle + 4294967295  ' - Val((tmpSingle * -1))  'Val(tmpSingle) + 
                Else
                    tmpDouble = tmpSingle
                End If

                tmpStr = Hex(tmpDouble)


                RequiredLength = BinaryStringLength * 2
                CurrentLength = tmpStr.Length
                AddZeroString = ""
                For tmploop = 1 To RequiredLength - CurrentLength
                    AddZeroString = AddZeroString & "0"
                Next

                tmpStr = AddZeroString & tmpStr

                For tmploop = 0 To BinaryStringLength - 1
                    BinaryFile(StartPos) = Convert.ToInt32(tmpStr.Substring(2 * tmploop, 2), 16)
                    StartPos += 1
                Next

            Next
        Next

        BinaryChanged = True

    End Sub
    Private Sub TreeView1_AfterSelect(ByVal sender As System.Object, ByVal e As System.Windows.Forms.TreeViewEventArgs) Handles TreeView1.AfterSelect

        If Not LoadingData Then

            If TreeView1.SelectedNode.Level = 1 Then
                EnableTreeMenu = True
            Else
                EnableTreeMenu = False
            End If


            If DatabaseLoaded Then
                If AddToGridToolStripMenuItem.Checked Then
                    Convert_Data_Database(TreeView1.SelectedNode.Text, True, False)
                Else
                    Convert_Data_Database(TreeView1.SelectedNode.Text, False, False)
                End If

            Else
                Convert_Data(GetNodeIndex(TreeView1.SelectedNode.Text))
            End If

            'Set CurrentTablePath
            CurrentTablePath = TreeView1.SelectedNode.FullPath.Replace("\", " -> ")

        End If

    End Sub

    Private Sub DataGridView1_CellValueChanged(ByVal sender As Object, ByVal e As System.Windows.Forms.DataGridViewCellEventArgs) Handles DataGridView1.CellValueChanged
        If Not LoadingData Then GridChanged = True
    End Sub

    Private Sub TreeView1_BeforeSelect(ByVal sender As Object, ByVal e As System.Windows.Forms.TreeViewCancelEventArgs) Handles TreeView1.BeforeSelect
        If GridChanged And Not LoadingData Then
            Try
                If Not AutoSaveTables Then
                    If MessageBox.Show("Do you want to save you changes to " & TreeView1.SelectedNode.Text, "Save Changes", MessageBoxButtons.YesNo, MessageBoxIcon.Question) = Windows.Forms.DialogResult.Yes Then
                        If DatabaseLoaded Then Save_Grid_Database() Else Save_Grid()
                        GridChanged = False
                    End If
                Else
                    If DatabaseLoaded Then Save_Grid_Database() Else Save_Grid()
                    GridChanged = False
                End If
            Catch ex As Exception
                MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            End Try
        End If

    End Sub

    Private Sub SaveBinaryToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SaveBinaryToolStripMenuItem.Click
        SaveTheChanges()
    End Sub

    Private Sub SaveTheChanges()

        If GridChanged And Not LoadingData Then
            If MessageBox.Show("Do you want to save you changes to " & TreeView1.SelectedNode.Text, "Save Changes", MessageBoxButtons.YesNo, MessageBoxIcon.Question) = Windows.Forms.DialogResult.Yes Then
                If DatabaseLoaded Then Save_Grid_Database() Else Save_Grid()
                GridChanged = False
            End If
        End If

        Dim Save_Dialog As New SaveFileDialog

        Save_Dialog.Filter = "Binary Files (*.bin)|*.bin"
        Save_Dialog.OverwritePrompt = True
        Save_Dialog.ShowDialog()

        If Not Save_Dialog.FileName = "" Then

            If Save_Binary_File(Save_Dialog.FileName) Then

                'Add to recent file list
                Recent_Files(4) = Recent_Files(3)
                Recent_Files(3) = Recent_Files(2)
                Recent_Files(2) = Recent_Files(1)
                Recent_Files(1) = Recent_Files(0)
                Recent_Files(0) = Save_Dialog.FileName

                SetRecentFiles()

                'Change caption to reflect newly created file
                Me.Text = "Tiny Tuner " & CurrentVersion.ToString & " - " & Save_Dialog.FileName

                MessageBox.Show(Save_Dialog.FileName & " has been saved.", "Changes Saved", MessageBoxButtons.OK, MessageBoxIcon.Information)

                BinaryChanged = False

                If Not SuppressPopups Then MsgBox("Finished saving file.")

            End If

        End If

    End Sub
    Private Sub frmTinyTuner_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing

        If Not CloseForm Then
            e.Cancel = True

            ExitToolStripMenuItem.PerformClick()
        Else
            Application.Exit()
        End If

    End Sub

    Private Sub frmTinyTuner_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        Me.Refresh()

        'MessageBox.Show("Form Load Start")

        ToolStripStatusLabel2.Text = ""
        ToolStripStatusLabel4.Text = ""
        ToolStripStatusLabel5.Text = ""
        ToolStripStatusLabel6.Text = ""
        ToolStripStatusLabel6.Text = ""
        ToolStripStatusLabel7.Text = ""
        lblStatusDataLocation.Text = ""

        AddToTableToolStripMenuItem.Enabled = False

        Me.Text = "Tiny Tuner " & CurrentVersion.ToString & " - Setting up menus"

        'MessageBox.Show("Form Load - InitRecentMenu()")
        InitRecentMenu()

        'MessageBox.Show("Form Load - InitOptionMenu()")
        InitOptionMenu()

        'MessageBox.Show("Form Load - InitToolsMenu(False)")
        InitToolsMenu(False)

        'Set status bar view menu items check marks
        SetStatusBarVisibilityMenuItems()

        'TextBox2.Text = "0-2%"
        'TextBox2.BackColor = Color.FromArgb(255, 0, 255, 0)  '
        'TextBox3.Text = "3-5%"
        'TextBox3.BackColor = Color.FromArgb(255, 64, 255, 0)  '32)
        'TextBox4.Text = "6-11%"
        'TextBox4.BackColor = Color.FromArgb(255, 128, 255, 0)  ' 64)
        'TextBox5.Text = "12-16%"
        'TextBox5.BackColor = Color.FromArgb(255, 196, 255, 0)  ' 96)
        'TextBox6.Text = "17-21%"
        'TextBox6.BackColor = Color.FromArgb(255, 255, 255, 0)  ' 128)
        'TextBox7.Text = "22-27%"
        'TextBox7.BackColor = Color.FromArgb(255, 255, 196, 0)  ' 96)
        'TextBox8.Text = "28-38%"
        'TextBox8.BackColor = Color.FromArgb(255, 255, 128, 0)  ' 64)
        'TextBox9.Text = "39-49&"
        'TextBox9.BackColor = Color.FromArgb(255, 255, 64, 0)  ' 32)
        'TextBox10.Text = "50% up"
        'TextBox10.BackColor = Color.FromArgb(255, 255, 0, 0)

        Me.Text = "Tiny Tuner " & CurrentVersion.ToString '& "  -  Database: " & DatabasePath

        'MessageBox.Show("Form Load - Define Dataset")
        dsTableData = New DataSet

    End Sub
    Private Sub InitToolsMenu(ByVal EnableMenu As Boolean)

        ChangeVINToolStripMenuItem.Enabled = EnableMenu
        ChangeSerialNumberToolStripMenuItem.Enabled = EnableMenu
        ExportTabelListToolStripMenuItem.Enabled = EnableMenu
        ExportAllTablesToolStripMenuItem.Enabled = EnableMenu
        ExportCurrentTableToolStripMenuItem.Enabled = EnableMenu
        ListDifferencesBetweenFilesToolStripMenuItem.Enabled = EnableMenu
        ExportCurentNodeListToolStripMenuItem.Enabled = EnableMenu
        ExportCurrentNodeToolStripMenuItem.Enabled = EnableMenu

    End Sub
    Private Sub InitOptionMenu()

        SetFolderPathOnImportToolStripMenuItem.Checked = SetFolderOnImport

        UseGridColorsToolStripMenuItem.Checked = UseGridColors

        DisplayWholeNumbersToolStripMenuItem.Checked = SuppressPopups

        ListDifferencesBetweenFilesToolStripMenuItem.Enabled = False

        AutoSaveDifferencesFilesToolStripMenuItem.Checked = AutoSaveDifferencesFile

        AutoSaveTablesStopBiggingMeToolStripMenuItem.Checked = AutoSaveTables

        UseDatabaseWhenAvailableToolStripMenuItem.Checked = UseDatabase

        ViewAllTablesToolStripMenuItem.Checked = ShowEverything

    End Sub
    Private Sub InitRecentMenu()

        'MessageBox.Show("InitRecentMenu - Start routine")

        ToolStripMenuItem6.Visible = False
        File1ToolStripMenuItem.Visible = False
        File2ToolStripMenuItem.Visible = False
        File3ToolStripMenuItem.Visible = False
        File4ToolStripMenuItem.Visible = False
        File5ToolStripMenuItem.Visible = False
        File1ToolStripMenuItem.Text = ""
        File2ToolStripMenuItem.Text = ""
        File3ToolStripMenuItem.Text = ""
        File4ToolStripMenuItem.Text = ""
        File5ToolStripMenuItem.Text = ""

        ErrorCount = 0

        'MessageBox.Show("InitRecentMenu - GetRecentFiles")
        GetRecentFiles()

        If ErrorCount < 1 Then
            'MessageBox.Show("InitRecentMenu - SetMenuProperties")
            SetMenuProperties()

            'MessageBox.Show("InitRecentMenu - Set File Menuitem Visibility")
            If File1ToolStripMenuItem.Text <> "" Then
                ToolStripMenuItem6.Visible = True
                File1ToolStripMenuItem.Visible = True
            End If
            If File2ToolStripMenuItem.Text <> "" Then File2ToolStripMenuItem.Visible = True
            If File3ToolStripMenuItem.Text <> "" Then File3ToolStripMenuItem.Visible = True
            If File4ToolStripMenuItem.Text <> "" Then File4ToolStripMenuItem.Visible = True
            If File5ToolStripMenuItem.Text <> "" Then File5ToolStripMenuItem.Visible = True
        End If

        'MessageBox.Show("InitRecentMenu - End Sub")
    End Sub

    Private Sub SetMenuProperties()


        Dim tmpString As String = ""
        Dim LastIndex As Integer


        If Recent_Files(0) <> "" Then
            LastIndex = Recent_Files(0).LastIndexOf("\") + 1
            tmpString = Recent_Files(0).Substring(LastIndex, Recent_Files(0).Length - LastIndex)
            File1ToolStripMenuItem.Text = tmpString
            File1ToolStripMenuItem.ToolTipText = Recent_Files(0)
        End If

        If Recent_Files(1) <> "" Then
            LastIndex = Recent_Files(1).LastIndexOf("\") + 1
            tmpString = Recent_Files(1).Substring(LastIndex, Recent_Files(1).Length - LastIndex)
            File2ToolStripMenuItem.Text = tmpString
            File2ToolStripMenuItem.ToolTipText = Recent_Files(1)
        End If

        If Recent_Files(2) <> "" Then
            LastIndex = Recent_Files(2).LastIndexOf("\") + 1
            tmpString = Recent_Files(2).Substring(LastIndex, Recent_Files(2).Length - LastIndex)
            File3ToolStripMenuItem.Text = tmpString
            File3ToolStripMenuItem.ToolTipText = Recent_Files(2)
        End If

        If Recent_Files(3) <> "" Then
            LastIndex = Recent_Files(3).LastIndexOf("\") + 1
            tmpString = Recent_Files(3).Substring(LastIndex, Recent_Files(3).Length - LastIndex)
            File4ToolStripMenuItem.Text = tmpString
            File4ToolStripMenuItem.ToolTipText = Recent_Files(3)
        End If

        If Recent_Files(4) <> "" Then
            LastIndex = Recent_Files(4).LastIndexOf("\") + 1
            tmpString = Recent_Files(4).Substring(LastIndex, Recent_Files(4).Length - LastIndex)
            File5ToolStripMenuItem.Text = tmpString
            File5ToolStripMenuItem.ToolTipText = Recent_Files(4)
        End If

    End Sub

    Private Sub ExitToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ExitToolStripMenuItem.Click

        Dim ContinueClosing As Boolean = True

        If GridChanged And Not LoadingData Then
            If MessageBox.Show("Do you want to save you changes to " & TreeView1.SelectedNode.Text, "Save Changes", MessageBoxButtons.YesNo, MessageBoxIcon.Question) = Windows.Forms.DialogResult.Yes Then
                Save_Grid()
                GridChanged = False
            End If
        End If

        If BinaryChanged Then
            Dim resp As MsgBoxResult = MessageBox.Show("Do you want to save your changes in the VCM file?", "Save Changes", MessageBoxButtons.YesNoCancel, MessageBoxIcon.Question, MessageBoxDefaultButton.Button1)

            Select Case resp

                Case MsgBoxResult.Cancel
                    CloseForm = False
                    ContinueClosing = False
                Case MsgBoxResult.No
                    'Do nothing, just close the program
                Case MsgBoxResult.Yes
                    'Save changes then close the program
                    SaveTheChanges()
                    If BinaryChanged Then
                        'Assume we hit Cancel on the SaveAs dialog.  
                        'Had we saved the file, the BinaryChanged flag would have been set to FALSE
                        ContinueClosing = False
                    End If
            End Select

        End If


        If ContinueClosing Then
            CloseForm = True
            Me.Close()
        End If

    End Sub

    Private Sub TableDescriptionToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        'GetNodeIndex(TreeView1.SelectedNode.Text)
        If Not TreeView1.SelectedNode Is Nothing Then
            Dim tmpMsg As String = ""
            Dim tmpText As String

            If Not IsDBNull(TreeView1.SelectedNode.Text) Then
                tmpText = TreeView1.SelectedNode.Text
            Else
                Exit Sub
            End If

            Dim tmpIndex As Integer = GetNodeIndex(tmpText)

            If tmpIndex < 1000 Then tmpMsg = AvailableTables(TP.Table_Description, tmpIndex)
            If tmpMsg = "" Or tmpIndex > 999 Then tmpMsg = "No description available"

            MessageBox.Show(tmpMsg, "Description Not Available", MessageBoxButtons.OK, MessageBoxIcon.Information)
        End If
    End Sub

    Private Sub ModifySelected(ByVal ModType As String, ByVal ModAmount As Single, ByVal Percentage As Boolean)

        Dim i As Integer = 0
        Dim a As Integer = 0
        Dim tmpVal As Single = 0
        Dim tmpPercentage As Single = ModAmount

        For i = 0 To DataGridView1.ColumnCount - 1
            For a = 0 To DataGridView1.RowCount - 1
                If DataGridView1.Item(i, a).Selected Then
                    If ModType.ToLower = "add" Then
                        If Percentage = False Then
                            tmpVal = DataGridView1.Item(i, a).Value + ModAmount
                            DataGridView1.Item(i, a).Value = tmpVal
                        Else
                            tmpPercentage = ModAmount / 100
                            tmpVal = DataGridView1.Item(i, a).Value * tmpPercentage
                            tmpVal = tmpVal + DataGridView1.Item(i, a).Value
                            DataGridView1.Item(i, a).Value = tmpVal
                        End If
                    ElseIf ModType.ToLower = "subtract" Then
                        If Percentage = False Then
                            tmpVal = DataGridView1.Item(i, a).Value - ModAmount
                            DataGridView1.Item(i, a).Value = tmpVal
                        Else
                            tmpPercentage = ModAmount / 100
                            tmpVal = DataGridView1.Item(i, a).Value * tmpPercentage
                            tmpVal = DataGridView1.Item(i, a).Value - tmpVal
                            DataGridView1.Item(i, a).Value = tmpVal
                        End If
                    End If
                End If
            Next
        Next

    End Sub

    Private Sub Add1ToSelectedToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Add1ToSelectedToolStripMenuItem.Click
        ModifySelected("Add", 1, False)
    End Sub

    Private Sub Add5ToSelectedToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Add5ToSelectedToolStripMenuItem.Click
        ModifySelected("Add", 5, False)
    End Sub

    Private Sub Add10ToSelectedToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Add10ToSelectedToolStripMenuItem.Click
        ModifySelected("Add", 10, False)
    End Sub

    Private Sub Add1ToSelcectedToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Add1ToSelcectedToolStripMenuItem.Click
        ModifySelected("Add", 1, True)
    End Sub

    Private Sub Add3ToSelectedToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Add3ToSelectedToolStripMenuItem.Click
        ModifySelected("Add", 3, True)
    End Sub

    Private Sub Add5ToSelectedToolStripMenuItem1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Add5ToSelectedToolStripMenuItem1.Click
        ModifySelected("Add", 5, True)
    End Sub

    Private Sub Subtract1FromSelectedToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Subtract1FromSelectedToolStripMenuItem.Click
        ModifySelected("Subtract", 1, False)
    End Sub

    Private Sub Subtract5FromSelectedToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Subtract5FromSelectedToolStripMenuItem.Click
        ModifySelected("Subtract", 5, False)
    End Sub

    Private Sub Subtract10FromSelectedToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Subtract10FromSelectedToolStripMenuItem.Click
        ModifySelected("Subtract", 10, False)
    End Sub

    Private Sub Subtract1FromSelectedToolStripMenuItem1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Subtract1FromSelectedToolStripMenuItem1.Click
        ModifySelected("Subtract", 1, True)
    End Sub

    Private Sub Subtract3FromSelectesToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Subtract3FromSelectesToolStripMenuItem.Click
        ModifySelected("Subtract", 3, True)
    End Sub

    Private Sub Subtract5FromSelectedToolStripMenuItem1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Subtract5FromSelectedToolStripMenuItem1.Click
        ModifySelected("Subtract", 5, True)
    End Sub

    Private Sub File1ToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles File1ToolStripMenuItem.Click
        If File1ToolStripMenuItem.Text <> "" Then
            LoadFile(File1ToolStripMenuItem.ToolTipText, True)
        End If
    End Sub

    Private Sub File2ToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles File2ToolStripMenuItem.Click
        If File2ToolStripMenuItem.Text <> "" Then
            LoadFile(File2ToolStripMenuItem.ToolTipText, True)
        End If
    End Sub

    Private Sub File3ToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles File3ToolStripMenuItem.Click
        If File3ToolStripMenuItem.Text <> "" Then
            LoadFile(File3ToolStripMenuItem.ToolTipText, True)
        End If
    End Sub

    Private Sub File4ToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles File4ToolStripMenuItem.Click
        If File4ToolStripMenuItem.Text <> "" Then
            LoadFile(File4ToolStripMenuItem.ToolTipText, True)
        End If
    End Sub

    Private Sub File5ToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles File5ToolStripMenuItem.Click
        If File5ToolStripMenuItem.Text <> "" Then
            LoadFile(File5ToolStripMenuItem.ToolTipText, True)
        End If
    End Sub

    Private Sub DataGridView1_CellContentClick(ByVal sender As System.Object, ByVal e As System.Windows.Forms.DataGridViewCellEventArgs) Handles DataGridView1.CellContentClick

    End Sub

    Private Sub ChangeVINToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ChangeVINToolStripMenuItem.Click

        Dim tmpString As String = InputBox("Enter the new VIN you want to save in this binary file.", "Change VIN", CurrentVIN)

        If tmpString.Length <> 17 Then
            If tmpString.Length <> 0 Then
                MsgBox("You must enter a 17 character string in order to change the VIN")
            End If
            Exit Sub
        End If

        tmpString = tmpString.ToUpper

        Dim StartPos As Integer = 16410
        If BinaryFile(StartPos) = 255 Then
            StartPos = 64602
        End If

        If BinaryFile(StartPos) = 255 Then
            MsgBox("Can not change VIN")
            Exit Sub
        End If

        Dim i As Integer
        For i = StartPos To StartPos + 16
            BinaryFile(i) = Asc(tmpString.Substring(i - StartPos, 1))
        Next

        If Not SuppressPopups Then MessageBox.Show("Finished saving the VIN number" & vbCrLf & vbCrLf & "New VIN = " & tmpString, _
                                                   "Change VIN", MessageBoxButtons.OK, MessageBoxIcon.Information)
    End Sub

    Private Sub ChangeSerialNumberToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ChangeSerialNumberToolStripMenuItem.Click

        Dim tmpString As String = InputBox("Enter the new Serial Number you want to save in this binary file.", "Change Serial Number", Currentserial)

        If tmpString.Length <> 10 Then
            If tmpString.Length <> 0 Then
                MsgBox("You must enter a 10 character string in order to change the Serial Number")
            End If
            Exit Sub
        End If

        tmpString = tmpString.ToUpper

        Dim StartPos As Integer = 16398
        If BinaryFile(StartPos) = 255 Then
            MessageBox.Show("Unable to change serial number")  '   StartPos = 64602
            Exit Sub
        End If

        If BinaryFile(StartPos) = 255 Then
            MsgBox("Can not change VIN")
            Exit Sub
        End If

        Dim i As Integer
        For i = StartPos To StartPos + 9
            BinaryFile(i) = Asc(tmpString.Substring(i - StartPos, 1))
        Next

        If Not SuppressPopups Then MessageBox.Show("Finished saving the VIN number" & vbCrLf & vbCrLf & "New VIN = " & tmpString, _
                                                   "Change VIN", MessageBoxButtons.OK, MessageBoxIcon.Information)
    End Sub

    Private Sub DisplayWholeNumbersToolStripMenuItem_AvailableChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles DisplayWholeNumbersToolStripMenuItem.AvailableChanged

    End Sub

    Private Sub DisplayWholeNumbersToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles DisplayWholeNumbersToolStripMenuItem.Click

        SuppressPopups = Not DisplayWholeNumbersToolStripMenuItem.Checked
        DisplayWholeNumbersToolStripMenuItem.Checked = SuppressPopups
        SetRecentFiles()

    End Sub

    Private Sub LinkBinaryToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles LinkBinaryToolStripMenuItem.Click

        If Not MessageBox.Show("Select a binary file to use to compare changes made to your imported binary." & vbCrLf & vbCrLf & _
                        "For instance, If you want to see the differences between a stock file and " & vbCrLf & _
                        "your current file, select a stock binary file.", "Select Control Bin", MessageBoxButtons.OKCancel, MessageBoxIcon.Information) = Windows.Forms.DialogResult.Cancel Then

            Dim tmpOpen As New OpenFileDialog
            tmpOpen.Filter = "Binary Files (*.bin)|*.bin"
            tmpOpen.ShowDialog()

            If Not tmpOpen.FileName = "" Then

                LinkedBinary = tmpOpen.FileName

                ImportLinkedBinary()

                If LinkedBinaryFileLoaded Then
                    Dim tmpString As String
                    Dim LastIndex As Integer
                    LastIndex = LinkedBinary.LastIndexOf("\") + 1
                    tmpString = LinkedBinary.Substring(LastIndex, LinkedBinary.Length - LastIndex)
                    LinkBinaryToolStripMenuItem.Text = "Control File - " & tmpString
                    SetRecentFiles()
                Else
                    UseGridColors = False
                    UseGridColorsToolStripMenuItem.Checked = False
                    LinkBinaryToolStripMenuItem.Text = "Control File - None"
                End If

            End If
        Else

            If LinkedBinaryFileLoaded Then
                If MessageBox.Show("Do you want to close the link with the control file?" & vbCrLf & vbCrLf & _
                                   "Choosing yes will disable grid colors.", "Kill Link", MessageBoxButtons.YesNo, MessageBoxIcon.Question) = Windows.Forms.DialogResult.Yes Then
                    LinkedBinary = ""
                    LinkedBinaryFileLoaded = False
                    UseGridColors = False
                    UseGridColorsToolStripMenuItem.Checked = False
                    LinkBinaryToolStripMenuItem.Text = "Control File - None"
                    SetRecentFiles()
                End If
            End If

        End If

        If LinkedBinaryFileLoaded Then ListDifferencesBetweenFilesToolStripMenuItem.Enabled = True Else ListDifferencesBetweenFilesToolStripMenuItem.Enabled = False

    End Sub

    Private Sub UseGridColorsToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles UseGridColorsToolStripMenuItem.Click

        UseGridColors = Not UseGridColorsToolStripMenuItem.Checked
        UseGridColorsToolStripMenuItem.Checked = UseGridColors
        SetRecentFiles()

    End Sub

    Private Sub ChooseColorsToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ChooseColorsToolStripMenuItem.Click

        Dim tmpColorDialog As New ColorDialog
        tmpColorDialog.ShowDialog()
        Dim tmpColor As Color
        tmpColor = tmpColorDialog.Color
        MsgBox(tmpColor.ToString)

    End Sub

    Private Sub MenuStrip1_ItemClicked(ByVal sender As System.Object, ByVal e As System.Windows.Forms.ToolStripItemClickedEventArgs) Handles MenuStrip1.ItemClicked

    End Sub

    Private Sub ExportAllTablesToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ExportAllTablesToolStripMenuItem.Click

        Dim SaveAsDiag As New SaveFileDialog
        SaveAsDiag.Filter = "Text Files (*.txt)|*.txt"
        SaveAsDiag.ShowDialog()

        If Not SaveAsDiag.FileName = "" Then

            Try

                ExportAllTables(SaveAsDiag.FileName)

            Catch ex As Exception
                MsgBox(ex.Message)
            End Try

        End If


        
    End Sub

    Private Sub ExportAllTables(ByVal SaveAsPath As String, Optional ByVal ListOnly As Boolean = False)

        Dim tt As New TinyTunerDLL.TableLocations
        Dim tmpArray() As String = tt.GetTables(GetMapNumber(Current_OSID), True)
        Array.Sort(tmpArray)

        Dim tmpwriter As New IO.StreamWriter(SaveAsPath, False)

        tmpwriter.WriteLine("This list was created on " & Now.ToLongDateString & " by the Tiny Tuner.")
        tmpwriter.WriteLine("File Location - " & LastBinLocation)
        tmpwriter.WriteLine("The Operating System ID is " & Current_OSID & " and contains " & TableCount.ToString & " tables.")
        tmpwriter.WriteLine(" ")

        Dim strTableName As String = ""
        Dim intTableCount As Int16 = 0

        Dim strCat As String = "", strTable As String = ""
        Dim intMainNodeCount As Int16 = TreeView1.Nodes.Count
        Dim intSubNodeCount As Int16 = 0
        Dim intTableNodeCount As Int16 = 0
        Dim strFirstNode As String = TreeView1.Nodes.Item(0).ToString

        Dim i As Int16, a As Int16, x As Int16
        For i = 0 To intMainNodeCount - 1
            intSubNodeCount = TreeView1.Nodes(i).Nodes.Count
            For a = 0 To intSubNodeCount - 1
                intTableNodeCount = TreeView1.Nodes(i).Nodes(a).Nodes.Count
                If intTableNodeCount > 0 Then
                    For x = 0 To intTableNodeCount - 1

                        If DatabaseLoaded Then
                            Convert_Data_Database(TreeView1.Nodes(i).Nodes(a).Nodes.Item(x).Text, False, False)
                        Else
                            Convert_Data(GetNodeIndex(TreeView1.Nodes(i).Nodes(a).Nodes.Item(x).Text))
                        End If

                        strTableName = TreeView1.Nodes(i).Text & " - " & TreeView1.Nodes(i).Nodes.Item(a).Text & " - " & TreeView1.Nodes(i).Nodes(a).Nodes.Item(x).Text
                        strTableName = strTableName.Replace("_", " ")
                        tmpwriter.WriteLine(strTableName)
                        intTableCount += 1


WaitHere:
                        If Not LoadingData Then
                            strTable = ExportDataGrid(True)
                        Else
                            Application.DoEvents()
                            GoTo WaitHere
                        End If

                        tmpwriter.WriteLine(strTable)

                        tmpwriter.WriteLine(" ")
                        tmpwriter.WriteLine(" ")

                    Next
                End If
            Next

        Next

        tmpwriter.Close()

        If Not SuppressPopups Then MsgBox("Finished saving tables to " & vbCrLf & SaveAsPath)

    End Sub

    Private Sub ExportCurrentNode(ByVal SaveAsPath As String, Optional ByVal ListOnly As Boolean = False)

        Dim tt As New TinyTunerDLL.TableLocations
        Dim tmpArray() As String = tt.GetTables(GetMapNumber(Current_OSID), True)
        Array.Sort(tmpArray)

        Dim tmpwriter As New IO.StreamWriter(SaveAsPath, False)

        tmpwriter.WriteLine("This list was created on " & Now.ToLongDateString & " by the Tiny Tuner.")
        tmpwriter.WriteLine("File Location - " & LastBinLocation)
        tmpwriter.WriteLine("The Operating System ID is " & Current_OSID & " and contains " & TableCount.ToString & " tables.")
        tmpwriter.WriteLine(" ")

        Dim strTableName As String = ""
        Dim intTableCount As Int16 = 0

        Dim strCat As String = "", strTable As String = ""
        Dim intMainNodeCount As Int16 = TreeView1.Nodes.Count
        Dim intSubNodeCount As Int16 = 0
        Dim intTableNodeCount As Int16 = 0
        Dim strFirstNode As String = TreeView1.Nodes.Item(0).ToString
        Dim CurrentNode As Integer = TreeView1.SelectedNode.Index

        Dim i As Int16, a As Int16, x As Int16
        'For i = 0 To intMainNodeCount - 1
        i = CurrentNode - 1
        intSubNodeCount = TreeView1.Nodes(i).Nodes.Count
        For a = 0 To intSubNodeCount - 1
            intTableNodeCount = TreeView1.Nodes(i).Nodes(a).Nodes.Count
            If intTableNodeCount > 0 Then
                For x = 0 To intTableNodeCount - 1

                    If DatabaseLoaded Then
                        Convert_Data_Database(TreeView1.Nodes(i).Nodes(a).Nodes.Item(x).Text, False, False)
                    Else
                        Convert_Data(GetNodeIndex(TreeView1.Nodes(i).Nodes(a).Nodes.Item(x).Text))
                    End If

                    strTableName = TreeView1.Nodes(i).Text & " - " & TreeView1.Nodes(i).Nodes.Item(a).Text & " - " & TreeView1.Nodes(i).Nodes(a).Nodes.Item(x).Text
                    strTableName = strTableName.Replace("_", " ")
                    tmpwriter.WriteLine(strTableName)
                    intTableCount += 1


WaitHere:
                    If Not LoadingData Then
                        strTable = ExportDataGrid(True)
                    Else
                        Application.DoEvents()
                        GoTo WaitHere
                    End If

                    tmpwriter.WriteLine(strTable)

                    tmpwriter.WriteLine(" ")
                    tmpwriter.WriteLine(" ")

                Next
            End If
        Next

        'Next

        tmpwriter.Close()

        If Not SuppressPopups Then MsgBox("Finished saving tables to " & vbCrLf & SaveAsPath)

    End Sub
    Private Sub ExportCurrentNode_Database(ByVal SaveAsPath As String, Optional ByVal ListOnly As Boolean = False)


        Dim tmpwriter As New IO.StreamWriter(SaveAsPath, False)

        tmpwriter.WriteLine("This list was created on " & Now.ToLongDateString & " by the Tiny Tuner.")
        tmpwriter.WriteLine("File Location - " & LastBinLocation)
        tmpwriter.WriteLine("The Operating System ID is " & Current_OSID & " and contains " & TableCount.ToString & " tables.")
        tmpwriter.WriteLine(" ")


        Dim TopNode As Boolean = False
        If TreeView1.SelectedNode.Level = 0 Then TopNode = True

        Dim RootNode As String = ""
        Dim ChildNode As String = ""
        If Not TopNode Then RootNode = TreeView1.SelectedNode.Parent.Text
        ChildNode = TreeView1.SelectedNode.Text


        Dim dt As New DataTable
        dt = dsTableData.Tables(0)

        Dim expression As String = ""
        Dim sortOrder As String = ""

        If TopNode Then
            expression = "MainCategory = '" & ChildNode & "'"
            sortOrder = "SubCategory ASC"
        Else
            expression = "MainCategory = '" & RootNode & "' AND SubCategory = '" & ChildNode & "'"
        End If

        Dim foundRows() As DataRow
        ' Use the Select method to find all rows matching the filter.
        foundRows = dt.Select(expression, sortOrder)

        Dim i As Integer
        Dim strTableName As String = ""
        Dim intTableCount As Int16 = 0
        Dim strTable As String = ""

        Dim CurrentCategory As String = ""

        tmpwriter.WriteLine(" ")
        If TopNode Then
            tmpwriter.WriteLine("The following " & foundRows.GetUpperBound(0) & " tables can be found in the folder " & ChildNode & vbCrLf)
        Else
            tmpwriter.WriteLine("The following " & foundRows.GetUpperBound(0) & " tables can be found in the folder " & RootNode & " -> " & ChildNode & vbCrLf)
        End If

        For i = 0 To foundRows.GetUpperBound(0)

            If Not CurrentCategory = foundRows(i).Item("SubCategory").ToString Then
                tmpwriter.WriteLine(" ")
                tmpwriter.WriteLine(foundRows(i).Item("SubCategory").ToString)
                tmpwriter.WriteLine("=======================================")
                CurrentCategory = foundRows(i).Item("SubCategory").ToString
            End If


            strTableName = foundRows(i).Item("TableName").ToString
            strTableName = strTableName.Replace("_", " ")
            tmpwriter.WriteLine(strTableName)
            intTableCount += 1


            If Not ListOnly Then

                If DatabaseLoaded Then
                    Convert_Data_Database(foundRows(i).Item("TableName").ToString, False, False)
                Else
                    Convert_Data(GetNodeIndex(foundRows(i).Item("TableName").ToString))
                End If

WaitHere:
                If Not LoadingData Then
                    strTable = ExportDataGrid(True)
                Else
                    Application.DoEvents()
                    GoTo WaitHere
                End If


                tmpwriter.WriteLine(strTable)

                tmpwriter.WriteLine(" ")
                tmpwriter.WriteLine(" ")
            End If



        Next

        tmpwriter.Close()

        If Not SuppressPopups Then MsgBox("Finished saving tables to " & vbCrLf & SaveAsPath)

    End Sub
    Private Sub ExportTableList(ByVal SaveAsPath As String)

        Dim tmpwriter As New IO.StreamWriter(SaveAsPath, False)

        tmpwriter.WriteLine("This list was created on " & Now.ToLongDateString & " by the Tiny Tuner.")
        tmpwriter.WriteLine("File Location - " & LastBinLocation)
        tmpwriter.WriteLine("The Operating System ID is " & Current_OSID & " and contains " & TableCount.ToString & " tables.")
        tmpwriter.WriteLine(" ")

        Dim strTableName As String = ""
        Dim intTableCount As Int16 = 0

        Dim strCat As String = ""
        Dim intMainNodeCount As Int16 = TreeView1.Nodes.Count
        Dim intSubNodeCount As Int16 = 0
        Dim intTableNodeCount As Int16 = 0
        Dim strFirstNode As String = TreeView1.Nodes.Item(0).ToString

        Dim i As Int16, a As Int16, x As Int16
        For i = 0 To intMainNodeCount - 1
            tmpwriter.WriteLine(TreeView1.Nodes(i).Text)
            intSubNodeCount = TreeView1.Nodes(i).Nodes.Count
            For a = 0 To intSubNodeCount - 1
                tmpwriter.WriteLine("    " & TreeView1.Nodes(i).Nodes.Item(a).Text)
                intTableNodeCount = TreeView1.Nodes(i).Nodes(a).Nodes.Count
                If intTableNodeCount > 0 Then
                    For x = 0 To intTableNodeCount - 1
                        'strTableName = TreeView1.Nodes(i).Text & " - " & TreeView1.Nodes(i).Nodes.Item(a).Text & " - " & TreeView1.Nodes(i).Nodes(a).Nodes.Item(x).Text
                        strTableName = TreeView1.Nodes(i).Nodes(a).Nodes.Item(x).Text
                        strTableName = strTableName.Replace("_", " ")
                        tmpwriter.WriteLine("        " & strTableName)
                        intTableCount += 1
                    Next
                    tmpwriter.WriteLine(" ")
                Else
                    'strTableName = TreeView1.Nodes(i).Text & " - " & TreeView1.Nodes(i).Nodes.Item(a).Text
                    'strTableName = TreeView1.Nodes(i).Nodes.Item(a).Text
                    'strTableName = strTableName.Replace("_", " ")
                    'tmpwriter.WriteLine("    " & strTableName)
                    intTableCount += 1
                End If

            Next
            tmpwriter.WriteLine(" ")

        Next

        tmpwriter.WriteLine(intTableCount.ToString & " tables listed")

        tmpwriter.Close()

        If Not SuppressPopups Then MsgBox("Finished exporting table list.")

    End Sub

    Private Function ExportSelected(Optional ByVal TableOnly As Boolean = False) As String

        Dim resp As String = "Error"
        Dim i, y, x As Integer

        Dim tmpString As String = ""
        Dim ColumnHeaders As String = ""

        Dim strTable As String = ""
        If Not TableOnly Then strTable = CurrentTablePath & vbCrLf & "File Location: " & LastBinLocation & vbCrLf & vbCrLf & Space(15) 'Label1.Text & " from " & LastBinLocation & vbCrLf & vbCrLf & Space(15)

        For i = 0 To DataGridView1.ColumnCount - 1  'Get Headers
            tmpString = DataGridView1.Columns(i).HeaderText
            If tmpString.Length > 10 Then tmpString = tmpString.Substring(0, 10)
            strTable += tmpString & Space(15 - tmpString.Length)
        Next

        strTable += vbCrLf

        For y = 0 To DataGridView1.RowCount - 1

            tmpString = DataGridView1.Rows(y).HeaderCell.Value.ToString

            If tmpString.Length > 10 Then tmpString = tmpString.Substring(0, 10)

            strTable += tmpString & Space(15 - tmpString.Length)

            For i = 0 To DataGridView1.ColumnCount - 1
                If DataGridView1.Item(i, y).Selected Then
                    tmpString = DataGridView1.Item(i, y).Value.ToString
                Else
                    tmpString = "!"
                End If

                If tmpString.Length > 10 Then tmpString = tmpString.Substring(0, 10)

                strTable += tmpString & Space(15 - tmpString.Length)
            Next

            strTable += vbCrLf
        Next

        resp = strTable

        ' See if we want just the table and NOT tinytuner data
        If Not TableOnly Then
            strTable = vbCrLf & vbCrLf & vbCrLf & "[TinyTunerData]" & vbCrLf

            For y = 0 To DataGridView1.RowCount - 1
                For i = 0 To DataGridView1.ColumnCount - 1
                    If DataGridView1.Item(i, y).Selected Then
                        tmpString = DataGridView1.Item(i, y).Value.ToString
                    Else
                        tmpString = "!"
                    End If
                    strTable += tmpString & ","
                Next
                strTable = strTable.Remove(strTable.Length - 1, 1)
                strTable += vbCrLf
            Next

            resp = resp & strTable
        End If


        Return resp

    End Function

    Private Function ExportDataGrid(Optional ByVal TableOnly As Boolean = False) As String

        Dim resp As String = "Error"
        Dim i, y, x As Integer

        Dim tmpString As String = ""
        Dim ColumnHeaders As String = ""

        Dim strTable As String = ""
        If Not TableOnly Then strTable = CurrentTablePath & vbCrLf & "File Location: " & LastBinLocation & vbCrLf & vbCrLf & Space(15) 'Label1.Text & " from " & LastBinLocation & vbCrLf & vbCrLf & Space(15)

        For i = 0 To DataGridView1.ColumnCount - 1  'Get Headers
            tmpString = DataGridView1.Columns(i).HeaderText
            If tmpString.Length > 10 Then tmpString = tmpString.Substring(0, 10)
            strTable += tmpString & Space(15 - tmpString.Length)
        Next

        strTable = Space(15) & strTable
        strTable += vbCrLf

        For y = 0 To DataGridView1.RowCount - 1

            tmpString = DataGridView1.Rows(y).HeaderCell.Value.ToString

            If tmpString.Length > 10 Then tmpString = tmpString.Substring(0, 10)

            strTable += tmpString & Space(15 - tmpString.Length)

            For i = 0 To DataGridView1.ColumnCount - 1
                tmpString = DataGridView1.Item(i, y).Value.ToString

                If tmpString.Length > 10 Then tmpString = tmpString.Substring(0, 10)

                strTable += tmpString & Space(15 - tmpString.Length)
            Next

            strTable += vbCrLf
        Next

        resp = strTable

        ' See if we want just the table and NOT tinytuner data
        If Not TableOnly Then
            strTable = vbCrLf & vbCrLf & vbCrLf & "[TinyTunerData]" & vbCrLf

            For y = 0 To DataGridView1.RowCount - 1
                For i = 0 To DataGridView1.ColumnCount - 1
                    tmpString = DataGridView1.Item(i, y).Value.ToString
                    strTable += tmpString & ","
                Next
                strTable = strTable.Remove(strTable.Length - 1, 1)
                strTable += vbCrLf
            Next

            resp = resp & strTable
        End If


        Return resp

    End Function

    Private Sub ExportCurrentTableToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ExportCurrentTableToolStripMenuItem.Click

        ExportCurrentTable()

    End Sub

    Private Sub ExportCurrentTable()

        Dim SaveAsDiag As New SaveFileDialog
        SaveAsDiag.InitialDirectory = ExportFolder
        SaveAsDiag.Filter = "Text Files (*.txt)|*.txt"
        SaveAsDiag.ShowDialog()

        If Not SaveAsDiag.FileName = "" Then

            If SetFolderOnImport Then
                'check to see if the export path is a UNC path or is on the local machine
                If SaveAsDiag.FileName.LastIndexOf("\") > 0 Then
                    'local machine
                    ExportFolder = SaveAsDiag.FileName.Substring(0, SaveAsDiag.FileName.LastIndexOf("\"))
                    SetRecentFiles()
                Else
                    If SaveAsDiag.FileName.LastIndexOf("/") > 0 Then
                        'Network drive
                        ExportFolder = SaveAsDiag.FileName.Substring(0, SaveAsDiag.FileName.LastIndexOf("/"))
                        SetRecentFiles()
                    End If
                End If
            End If

            Dim tmpwriter As New IO.StreamWriter(SaveAsDiag.FileName, False)

            Try
                tmpwriter.WriteLine(ExportDataGrid)

            Catch ex As Exception
                MsgBox(ex.Message)
            Finally
                tmpwriter.Close()
            End Try
        End If

    End Sub


    Private Sub DatagridMenu_Opening(ByVal sender As System.Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles DatagridMenu.Opening

        If LinkedBinaryFileLoaded Then
            FromLinkedBinToolStripMenuItem.Enabled = True
        Else
            FromLinkedBinToolStripMenuItem.Enabled = False
        End If

        ImportToolStripMenuItem.Enabled = True

        If DataGridView1.Columns.Count = 1 Then
            ImportToolStripMenuItem.Enabled = True
        End If

        'see if we want to enable importing from an HPT exported file
        Dim OKtoDisplay As Boolean = False
        Select Case CurrentTablePath
            Case "Spark -> Base Timing -> Bad Fuel Spark"
                OKtoDisplay = True
            Case "Spark -> Base Timing -> Good Fuel Spark"
                OKtoDisplay = True
            Case "Spark -> Base Timing -> Mean Best Torque Spark"
                OKtoDisplay = True
            Case "Fuel -> MAF -> MAF Airflow Table"
                OKtoDisplay = True
            Case "Fuel -> MAF -> MAF Table - Airflow vs Frequency"
                OKtoDisplay = True
        End Select
        FromHPTunerTextFileToolStripMenuItem.Enabled = OKtoDisplay

    End Sub

    Private Sub ContextMenuStrip1_Opening(ByVal sender As System.Object, ByVal e As System.ComponentModel.CancelEventArgs)

    End Sub

    Private Sub Subtract10FromSelectedToolStripMenuItem1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Subtract10FromSelectedToolStripMenuItem1.Click
        ModifySelected("Subtract", 10, True)
    End Sub

    Private Sub Add10ToSelectedToolStripMenuItem1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Add10ToSelectedToolStripMenuItem1.Click
        ModifySelected("Add", 10, True)
    End Sub


    Private Sub LostAvailableSupportToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles LostAvailableSupportToolStripMenuItem.Click

        Dim tmpString As String = "99,98,97,96,95,94,93,92,90,89,87,85,49,48,47,45,39,10,1001,1002"
        SupportedMaps = tmpString.Split(",")
        Dim OSID_List() As String

        Dim MapCount As Int16 = UBound(SupportedMaps)
        tmpString = ""

        Dim tt As New TinyTunerDLL.TableLocations
        Dim i As Int16
        For i = 0 To MapCount - 1
            tmpString += GetMapSupport(SupportedMaps(i)) & ","
        Next

        tmpString = tmpString.Replace(" ", "")
        OSID_List = tmpString.Split(",")
        Array.Sort(OSID_List)
        Array.Sort(OSID_List)
        tmpString = ""
        Dim First9 As Boolean = False

        Dim tmpCount As Int16 = 0

        For i = 0 To UBound(OSID_List) - 1

            If OSID_List(i).StartsWith("9") And First9 = False Then
                tmpString = vbCrLf & vbCrLf & tmpString
                First9 = True
            End If

            tmpString = tmpString & OSID_List(i).ToString

            If tmpCount > 10 Then
                tmpCount = 0
                tmpString = tmpString & vbCrLf
            Else
                If tmpCount > 0 Then tmpString = tmpString & "  -  "
            End If

            tmpCount += 1

        Next

        tmpString = tmpString & vbCrLf & vbCrLf & MapCount.ToString & " supported Maps  " & UBound(OSID_List).ToString & " supported OSIDs"
        MsgBox(tmpString)

    End Sub

    Private Sub ExportTabelListToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ExportTabelListToolStripMenuItem.Click

        Dim SaveAsDiag As New SaveFileDialog
        SaveAsDiag.Filter = "Text Files (*.txt)|*.txt"
        SaveAsDiag.ShowDialog()

        If Not SaveAsDiag.FileName = "" Then

            Try
                ExportTableList(SaveAsDiag.FileName)
            Catch ex As Exception
                MsgBox(ex.Message)
            End Try

        End If

    End Sub

    Private Sub ExportToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ExportToolStripMenuItem.Click

    End Sub

    Private Sub FromClipboardToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles FromClipboardToolStripMenuItem.Click

        ImportTableFromClipboard()

    End Sub

    Private Sub ImportTableFromClipboard()

        Dim tmptext As String = Clipboard.GetText
        tmptext = tmptext.Replace(Chr(10), "")

        Dim tmpStringArray() As String = tmptext.Split(Chr(13))

        Dim tmpString As String = ""
        Dim HaveData As Boolean = False
        Dim ImportedRowCount As Int16 = 1
        Dim tmpTableArray() As String
        Dim ImportError As Boolean = False
        Dim a As Int16

        'First, read the data in to an array so we can check it before importing to the datagrid
        Try
            For a = 0 To tmpStringArray.Length - 1
                tmpString = tmpStringArray(a)

                If tmpString = "[TinyTunerData]" Then HaveData = True

                If HaveData Then

                    If tmpString = Nothing Then Exit For

                    If tmpString.Contains("!") Then
                        MsgBox("The data in the clipboard only contains a portion of this table." & vbCrLf & _
                               "If you want to import this data, please select the ""Paste Selected"" option from the menu.", MsgBoxStyle.Exclamation)
                        HaveData = False
                    End If

                    If Not tmpString = "[TinyTunerData]" Then
                        If Not tmpString = "" Then
                            ReDim Preserve tmpTableArray(ImportedRowCount)
                            tmpTableArray(ImportedRowCount) = tmpString
                            ImportedRowCount += 1
                        End If
                    End If
                End If

            Next

            If Not HaveData Then
                ImportError = True
                MessageBox.Show("The clipboard does not contain usable data to import to this table.", "Import Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            End If


            If Not ImportError Then
                ImportError = ImportData(tmpTableArray, ImportedRowCount)
            End If


        Catch ex As Exception
            ImportError = True
            MessageBox.Show(ex.Message)

        End Try

        If Not ImportError Then
            If Not SuppressPopups Then MessageBox.Show("The clipboard data was successfully imported", "Table Imported", MessageBoxButtons.OK, MessageBoxIcon.Information)
        End If

    End Sub

    Private Sub ImportSelectedFromClipboard()

        Dim tmptext As String = Clipboard.GetText
        tmptext = tmptext.Replace(Chr(10), "")

        Dim tmpStringArray() As String = tmptext.Split(Chr(13))

        Dim tmpString As String = ""
        Dim HaveData As Boolean = False
        Dim ImportedRowCount As Int16 = 1
        Dim tmpTableArray() As String
        Dim ImportError As Boolean = False
        Dim a As Int16

        'First, read the data in to an array so we can check it before importing to the datagrid
        Try
            For a = 0 To tmpStringArray.Length - 1
                tmpString = tmpStringArray(a)

                If tmpString = "[TinyTunerData]" Then HaveData = True

                If HaveData Then

                    If tmpString = Nothing Then Exit For

                    If Not tmpString = "[TinyTunerData]" Then
                        If Not tmpString = "" Then
                            ReDim Preserve tmpTableArray(ImportedRowCount)
                            tmpTableArray(ImportedRowCount) = tmpString
                            ImportedRowCount += 1
                        End If
                    End If
                End If

            Next

            If Not HaveData Then
                ImportError = True
                MessageBox.Show("The clipboard does not contain usable data to import to this table.", "Import Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            End If


            If Not ImportError Then
                ImportError = ImportSelectedData(tmpTableArray, ImportedRowCount)
            End If


        Catch ex As Exception
            ImportError = True
            MessageBox.Show(ex.Message)

        End Try

        If Not ImportError Then
            If Not SuppressPopups Then MessageBox.Show("The clipboard data was successfully imported", "Table Imported", MessageBoxButtons.OK, MessageBoxIcon.Information)
        End If

    End Sub

    Private Sub FromFileToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles FromFileToolStripMenuItem.Click

        ImportTableFromFile()

    End Sub

    Private Sub ImportTableFromFile()

        Dim OpenDialog As New OpenFileDialog
        OpenDialog.InitialDirectory = ImportFolder
        OpenDialog.Filter = "Tiny Tuner Exported Tables (*.txt)|*.txt"
        OpenDialog.ShowDialog()

        If Not OpenDialog.FileName = "" Then

            If SetFolderOnImport Then
                'check to see if the export path is a UNC path or is on the local machine
                If OpenDialog.FileName.LastIndexOf("\") > 0 Then
                    'local machine
                    ImportFolder = OpenDialog.FileName.Substring(0, OpenDialog.FileName.LastIndexOf("\"))
                    SetRecentFiles()
                Else
                    If OpenDialog.FileName.LastIndexOf("/") > 0 Then
                        'Network drive
                        ImportFolder = OpenDialog.FileName.Substring(0, OpenDialog.FileName.LastIndexOf("/"))
                        SetRecentFiles()
                    End If
                End If
            End If

            Dim tmpString As String = ""
            Dim HaveData As Boolean = False
            Dim ImportedRowCount As Int16 = 1
            Dim tmpReader As IO.StreamReader
            Dim tmpTableArray() As String
            Dim ImportError As Boolean = False

            'First, read the data in to an array so we can check it before importing to the datagrid
            Try
                tmpReader = New IO.StreamReader(OpenDialog.FileName)
                Do
                    tmpString = tmpReader.ReadLine
                    If tmpString = "[TinyTunerData]" Then HaveData = True

                    If HaveData Then
                        If Not tmpString = "[TinyTunerData]" Then
                            If Not tmpString = "" Then
                                ReDim Preserve tmpTableArray(ImportedRowCount)
                                tmpTableArray(ImportedRowCount) = tmpString
                                ImportedRowCount += 1
                            End If
                        End If
                    End If
                Loop Until tmpReader.EndOfStream

                If Not HaveData Then
                    ImportError = True
                    MessageBox.Show("The file located at " & OpenDialog.FileName & vbCrLf & "does not contain usable data to import to this table.", "Import Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
                End If


                If Not ImportError Then
                    ImportError = ImportData(tmpTableArray, ImportedRowCount)
                End If


            Catch ex As Exception
                ImportError = True
                MessageBox.Show(ex.Message)
            Finally
                tmpReader.Close()
            End Try

            If Not ImportError Then
                If Not SuppressPopups Then MessageBox.Show("The table located at " & OpenDialog.FileName & " was successfully imported", "Table Imported", MessageBoxButtons.OK, MessageBoxIcon.Information)
            End If

        End If

    End Sub

    Private Function ImportData(ByVal tmpDataArray() As String, ByVal ImportedRowCount As Int16, Optional ByVal BaseZero As Boolean = False) As Boolean

        Dim ImportError As Boolean = False

        'OK, if that went alright then let's verify the imported table structure
        If BaseZero Then
            If ImportedRowCount - 1 = DataGridView1.RowCount Then
                ImportError = True
            End If
        Else
            If ImportedRowCount + 1 = DataGridView1.RowCount Then
                ImportError = True
            End If
        End If

        If Not ImportError Then

            'Row count matches, lets check the column colunm now
            Dim i As Int16, b As Int16
            Dim tmpArray() As String
            For i = 0 To DataGridView1.RowCount - 1
                If BaseZero Then
                    tmpArray = tmpDataArray(i).Split(",")
                Else
                    tmpArray = tmpDataArray(i + 1).Split(",")
                End If

                If tmpArray.Length = DataGridView1.ColumnCount Then
                    'We're good, lets import the tables to the datagrid
                    For b = 0 To DataGridView1.ColumnCount - 1
                        DataGridView1.Rows(i).Cells(b).Value = tmpArray(b).ToString
                    Next
                Else
                    MessageBox.Show("The table you are trying to import does not have the same structure as the table you are trying to replace.  " & vbCrLf & _
                                    "There are " & tmpArray.Length.ToString & " columns in the imported table, and " & DataGridView1.ColumnCount.ToString & " columns in the displayed table.", "Incorrect Table Structure", MessageBoxButtons.OK, MessageBoxIcon.Error)

                    ImportError = True
                    Exit For
                End If

            Next

        End If

        If ImportError Then
            If BaseZero Then
                MessageBox.Show("The table you are trying to import does not have the same structure as the table you are trying to replace.  " & vbCrLf & _
                                            "There are " & (ImportedRowCount + 1).ToString & " rows in the imported table, and " & DataGridView1.RowCount.ToString & " rows in the displayed table.", "Incorrect Table Structure", MessageBoxButtons.OK, MessageBoxIcon.Error)

            Else
                MessageBox.Show("The table you are trying to import does not have the same structure as the table you are trying to replace.  " & vbCrLf & _
                                            "There are " & (ImportedRowCount - 1).ToString & " rows in the imported table, and " & DataGridView1.RowCount.ToString & " rows in the displayed table.", "Incorrect Table Structure", MessageBoxButtons.OK, MessageBoxIcon.Error)

            End If
            ImportError = True
        End If

        Return (ImportError)

    End Function

    Private Function ImportSelectedData(ByVal tmpDataArray() As String, ByVal ImportedRowCount As Int16, Optional ByVal BaseZero As Boolean = False) As Boolean

        Dim ImportError As Boolean = False

        'OK, if that went alright then let's verify the imported table structure
        If BaseZero Then
            If ImportedRowCount - 1 = DataGridView1.RowCount Then
                ImportError = True
            End If
        Else
            If ImportedRowCount + 1 = DataGridView1.RowCount Then
                ImportError = True
            End If
        End If

        If Not ImportError Then

            'Row count matches, lets check the column colunm now
            Dim i As Int16, b As Int16
            Dim tmpArray() As String
            For i = 0 To DataGridView1.RowCount - 1
                If BaseZero Then
                    tmpArray = tmpDataArray(i).Split(",")
                Else
                    tmpArray = tmpDataArray(i + 1).Split(",")
                End If

                If tmpArray.Length = DataGridView1.ColumnCount Then
                    'We're good, lets import the tables to the datagrid
                    For b = 0 To DataGridView1.ColumnCount - 1
                        If Not tmpArray(b).ToString = "!" Then DataGridView1.Rows(i).Cells(b).Value = tmpArray(b).ToString
                    Next
                Else
                    MessageBox.Show("The table you are trying to import does not have the same structure as the table you are trying to replace.  " & vbCrLf & _
                                    "There are " & tmpArray.Length.ToString & " columns in the imported table, and " & DataGridView1.ColumnCount.ToString & " columns in the displayed table.", "Incorrect Table Structure", MessageBoxButtons.OK, MessageBoxIcon.Error)

                    ImportError = True
                    Exit For
                End If

            Next

        End If

        If ImportError Then
            If BaseZero Then
                MessageBox.Show("The table you are trying to import does not have the same structure as the table you are trying to replace.  " & vbCrLf & _
                                            "There are " & (ImportedRowCount + 1).ToString & " rows in the imported table, and " & DataGridView1.RowCount.ToString & " rows in the displayed table.", "Incorrect Table Structure", MessageBoxButtons.OK, MessageBoxIcon.Error)

            Else
                MessageBox.Show("The table you are trying to import does not have the same structure as the table you are trying to replace.  " & vbCrLf & _
                                            "There are " & (ImportedRowCount - 1).ToString & " rows in the imported table, and " & DataGridView1.RowCount.ToString & " rows in the displayed table.", "Incorrect Table Structure", MessageBoxButtons.OK, MessageBoxIcon.Error)

            End If
            ImportError = True
        End If

        Return (ImportError)

    End Function

    Private Sub FromLinkedBinToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles FromLinkedBinToolStripMenuItem.Click
        If LinkedBinaryFileLoaded Then
            If Not LoadingData Then
                If DatabaseLoaded Then
                    Convert_Data_Database(TreeView1.SelectedNode.Text, False, True)
                Else
                    Convert_Data(GetNodeIndex(TreeView1.SelectedNode.Text), True)
                End If

            End If
        End If
    End Sub

    Private Sub FillSelectedCellsToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles FillSelectedCellsToolStripMenuItem.Click

        FillSelectedCells()

    End Sub

    Private Sub FillSelectedCells()

        Dim tmpDialog As New Dialog1
        tmpDialog.ShowDialog()

        If Not tmpDialog.EnteredValue = "" Then

            Dim a As Int16, b As Int16

            For a = 0 To DataGridView1.RowCount - 1
                For b = 0 To DataGridView1.ColumnCount - 1
                    If DataGridView1.Rows(a).Cells(b).Selected Then
                        DataGridView1.Rows(a).Cells(b).Value = tmpDialog.EnteredValue
                    End If
                Next
            Next

            If Not SuppressPopups Then MessageBox.Show("Finished!")

        End If

    End Sub

    Private Sub SetFolderPathOnImportToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SetFolderPathOnImportToolStripMenuItem.Click

        SetFolderOnImport = Not SetFolderPathOnImportToolStripMenuItem.Checked
        SetFolderPathOnImportToolStripMenuItem.Checked = SetFolderOnImport
        SetRecentFiles()

    End Sub

    Private Sub ToiFileToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToiFileToolStripMenuItem.Click
        ExportCurrentTable()
    End Sub

    Private Sub ToClipboardToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToClipboardToolStripMenuItem.Click

        Clipboard.Clear()
        Clipboard.SetText(ExportDataGrid)

    End Sub

    Private Sub GetMAPNumberForAnOSIDToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles GetMAPNumberForAnOSIDToolStripMenuItem.Click
        Dim tmpString As String = InputBox("Enter the OSID", "Cross OSID", Current_OSID)

        Dim tt As New TinyTunerDLL.TableLocations
        MessageBox.Show("The MAP numbner is " & GetMapNumber(Val(tmpString)).ToString & " for " & tmpString)
    End Sub

    Private Sub MultiplyByPercentToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MultiplyByPercentToolStripMenuItem.Click

        Dim tmpDialog As New Dialog1
        tmpDialog.Label1.Text = "Enter the percentage in the box below that you want MULTIPLIED to the selected cells." & vbCrLf & "Entering 100 will not change the value."
        tmpDialog.ShowDialog()

        If Not tmpDialog.EnteredValue = "" Then

            Dim a As Int16, b As Int16

            For a = 0 To DataGridView1.RowCount - 1
                For b = 0 To DataGridView1.ColumnCount - 1
                    If DataGridView1.Rows(a).Cells(b).Selected Then
                        DataGridView1.Rows(a).Cells(b).Value = (Val(DataGridView1.Rows(a).Cells(b).Value) * (Val(tmpDialog.EnteredValue) / 100)).ToString
                    End If
                Next
            Next

            If Not SuppressPopups Then MessageBox.Show("Finished!")

        End If

    End Sub


    Private Sub AddToSelectedToolStripMenuItem1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AddToSelectedToolStripMenuItem1.Click

        Dim tmpDialog As New Dialog1
        tmpDialog.Label1.Text = "Enter the amount in the box below that you want ADDED to the selected cells."
        tmpDialog.ShowDialog()

        If Not tmpDialog.EnteredValue = "" Then

            Dim a As Int16, b As Int16

            For a = 0 To DataGridView1.RowCount - 1
                For b = 0 To DataGridView1.ColumnCount - 1
                    If DataGridView1.Rows(a).Cells(b).Selected Then
                        DataGridView1.Rows(a).Cells(b).Value = (Val(DataGridView1.Rows(a).Cells(b).Value) + (Val(tmpDialog.EnteredValue))).ToString
                    End If
                Next
            Next

            If Not SuppressPopups Then MessageBox.Show("Finished!")

        End If

    End Sub

    Private Sub SubtractFromSelectedToolStripMenuItem1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SubtractFromSelectedToolStripMenuItem1.Click

        Dim tmpDialog As New Dialog1
        tmpDialog.Label1.Text = "Enter the amount in the box below that you want SUBTRACTED to the selected cells."
        tmpDialog.ShowDialog()

        If Not tmpDialog.EnteredValue = "" Then

            Dim a As Int16, b As Int16

            For a = 0 To DataGridView1.RowCount - 1
                For b = 0 To DataGridView1.ColumnCount - 1
                    If DataGridView1.Rows(a).Cells(b).Selected Then
                        DataGridView1.Rows(a).Cells(b).Value = (Val(DataGridView1.Rows(a).Cells(b).Value) - (Val(tmpDialog.EnteredValue))).ToString
                    End If
                Next
            Next

            If Not SuppressPopups Then MessageBox.Show("Finished!")

        End If

    End Sub

    Private Sub ListDifferencesBetweenFilesToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ListDifferencesBetweenFilesToolStripMenuItem.Click

        If LinkedBinaryFileLoaded Then

            Dim SaveFilePath As String = ""

            If Not System.IO.Directory.Exists(ExportFolder) Then ExportFolder = Application.StartupPath

            If AutoSaveDifferencesFile Then
                SaveFilePath = ExportFolder & "\_Differences.txt"
            Else
                Dim SaveAsDiag As New SaveFileDialog
                SaveAsDiag.InitialDirectory = ExportFolder
                SaveAsDiag.Filter = "Text Files (*.txt)|*.txt"
                SaveAsDiag.ShowDialog()
                SaveFilePath = SaveAsDiag.FileName
            End If

            If Not SaveFilePath = "" Then

                Try
                    If DatabaseLoaded Then
                        ListDifferentTables_Database(SaveFilePath, True)
                    Else
                        ListDifferentTables(SaveFilePath, True)
                    End If


                    Shell("notepad.exe " & SaveFilePath, AppWinStyle.MaximizedFocus)
                Catch ex As Exception
                    MsgBox(ex.Message)
                End Try

            End If
        Else

            CompareBinaries()

        End If


    End Sub

    Private Sub ListDifferentTables(ByVal SaveAsPath As String, Optional ByVal ListOnly As Boolean = False)

        Dim tt As New TinyTunerDLL.TableLocations
        Dim tmpArray() As String = tt.GetTables(GetMapNumber(Current_OSID), True)
        Array.Sort(tmpArray)

        Dim tmpwriter As New IO.StreamWriter(SaveAsPath, False)

        tmpwriter.WriteLine("This list was created on " & Now.ToLongDateString & " by the Tiny Tuner.")
        tmpwriter.WriteLine(" ")

        tmpwriter.WriteLine("Main File Location - " & LastBinLocation)
        tmpwriter.WriteLine("Compare File Location - " & LinkedBinary)
        tmpwriter.WriteLine(" ")

        tmpwriter.WriteLine("The Operating System ID is " & Current_OSID & " and contains " & TableCount.ToString & " tables.")
        tmpwriter.WriteLine(" ")

        Dim strTableName As String = ""
        Dim intTableCount As Int16 = 0

        Dim strCat As String = "", strTable As String = ""
        Dim intMainNodeCount As Int16 = TreeView1.Nodes.Count
        Dim intSubNodeCount As Int16 = 0
        Dim intTableNodeCount As Int16 = 0
        Dim strFirstNode As String = TreeView1.Nodes.Item(0).ToString

        Dim MainHeaderWritten As Boolean = False, SecHeaderWritten As Boolean = False
        Dim MainHeader As String = "", SecHeader As String = ""

        Dim i As Int16, a As Int16, x As Int16
        For i = 0 To intMainNodeCount - 1
            intSubNodeCount = TreeView1.Nodes(i).Nodes.Count
            'tmpwriter.WriteLine(TreeView1.Nodes(i).Text)
            MainHeader = TreeView1.Nodes(i).Text
            MainHeaderWritten = False
            For a = 0 To intSubNodeCount - 1
                intTableNodeCount = TreeView1.Nodes(i).Nodes(a).Nodes.Count
                'tmpwriter.WriteLine("     " & TreeView1.Nodes(i).Nodes.Item(a).Text)
                SecHeader = "     " & TreeView1.Nodes(i).Nodes.Item(a).Text
                SecHeaderWritten = False
                If intTableNodeCount > 0 Then
                    For x = 0 To intTableNodeCount - 1

                        If Compare_Data(GetNodeIndex(TreeView1.Nodes(i).Nodes(a).Nodes.Item(x).Text)) Then

                            'strTableName = TreeView1.Nodes(i).Text & " - " & TreeView1.Nodes(i).Nodes.Item(a).Text & " - " & TreeView1.Nodes(i).Nodes(a).Nodes.Item(x).Text

                            If MainHeaderWritten = False Then
                                MainHeaderWritten = True
                                tmpwriter.WriteLine(MainHeader)
                            End If

                            If SecHeaderWritten = False Then
                                SecHeaderWritten = True
                                tmpwriter.WriteLine(SecHeader)
                            End If

                            strTableName = "          " & TreeView1.Nodes(i).Nodes(a).Nodes.Item(x).Text
                            strTableName = strTableName.Replace("_", " ")
                            tmpwriter.WriteLine(strTableName)
                            intTableCount += 1


WaitHere:
                            If Not LoadingData Then
                                'strTable = ExportDataGrid()
                            Else
                                Application.DoEvents()
                                GoTo WaitHere
                            End If

                        End If
                    Next
                    If SecHeaderWritten = True Then tmpwriter.WriteLine(" ")
                Else


                    If Compare_Data(GetNodeIndex(TreeView1.Nodes(i).Nodes.Item(a).Text)) Then

                        If MainHeaderWritten = False Then
                            MainHeaderWritten = True
                            tmpwriter.WriteLine(MainHeader)
                        End If

                        strTableName = "     " & TreeView1.Nodes(i).Nodes.Item(a).Text
                        strTableName = strTableName.Replace("_", " ")
                        tmpwriter.WriteLine(strTableName)
                        intTableCount += 1
                    End If

                End If
            Next
            If MainHeaderWritten = True Then tmpwriter.WriteLine(" ")
        Next

        tmpwriter.Close()

        If Not SuppressPopups Then MsgBox("Finished saving tables to " & vbCrLf & SaveAsPath)

    End Sub

    Private Function Compare_Data(ByVal List_Index As Integer) As Boolean

        Dim resp As Boolean = False

        'Start position - the first 4 characters are the row, the last 1 is the column
        Dim str_Start_Row As String = AvailableTables(TP.Start_Position, List_Index)

        'Number of rows intable
        Dim Row_Count As Integer = Val(AvailableTables(TP.Row_Count, List_Index))
        Dim Column_Count As Integer = Val(AvailableTables(TP.Column_Count, List_Index))
        Dim ByteCount As Int16 = Column_Count * Row_Count

        'Number of bits per cell
        Dim Element_Size As Integer = Val(AvailableTables(TP.Element_Size, List_Index))
        Dim tmpHexString As String, tmpHexString2 As String, str1 As String, str2 As String
        Dim HexPosition As Long = Convert.ToInt32(str_Start_Row, 16)
        Dim ColCounter As Int16, RowCounter As Int16, i As Int16, esCounter As Int16

        resp = False

        For ColCounter = 0 To Column_Count - 1
            For i = 0 To Row_Count - 1
                For esCounter = 1 To Element_Size
                    tmpHexString = Hex(BinaryFile(HexPosition))
                    tmpHexString2 = Hex(LinkedBinaryFile(HexPosition))
                    HexPosition += 1
                    If tmpHexString.Length < 2 Then
                        str1 += "0" & tmpHexString
                    Else
                        str1 += tmpHexString
                    End If

                    If Not LinkedBinary = "" And tmpHexString2.Length < 2 Then
                        str2 += "0" & tmpHexString2
                    Else
                        str2 += tmpHexString2
                    End If

                    If Not str1 = str2 Then
                        resp = True
                    End If
                Next
            Next
        Next


        Return resp

    End Function




















    Private Sub ListDifferentTables_Database(ByVal SaveAsPath As String, Optional ByVal ListOnly As Boolean = False)

        Dim tmpwriter As New IO.StreamWriter(SaveAsPath, False)

        tmpwriter.WriteLine("This list was created on " & Now.ToLongDateString & " by the Tiny Tuner.")
        tmpwriter.WriteLine(" ")

        tmpwriter.WriteLine("Main File Location - " & LastBinLocation)
        tmpwriter.WriteLine("Compare File Location - " & LinkedBinary)
        tmpwriter.WriteLine(" ")

        tmpwriter.WriteLine("The Operating System ID is " & Current_OSID & " and contains " & dsTableData.Tables(0).Rows.Count.ToString & " tables.")
        tmpwriter.WriteLine(" ")

        Dim strTableName As String = ""
        Dim intTableCount As Int16 = 0

        Dim strCat As String = "", strTable As String = ""
        Dim intMainNodeCount As Int16 = TreeView1.Nodes.Count
        Dim intSubNodeCount As Int16 = 0
        Dim intTableNodeCount As Int16 = 0
        Dim strFirstNode As String = TreeView1.Nodes.Item(0).ToString

        Dim MainHeaderWritten As Boolean = False, SecHeaderWritten As Boolean = False
        Dim MainHeader As String = "", SecHeader As String = ""

        Dim i As Int16, a As Int16, x As Int16
        For i = 0 To intMainNodeCount - 1
            intSubNodeCount = TreeView1.Nodes(i).Nodes.Count
            'tmpwriter.WriteLine(TreeView1.Nodes(i).Text)
            MainHeader = TreeView1.Nodes(i).Text
            MainHeaderWritten = False
            For a = 0 To intSubNodeCount - 1
                intTableNodeCount = TreeView1.Nodes(i).Nodes(a).Nodes.Count
                'tmpwriter.WriteLine("     " & TreeView1.Nodes(i).Nodes.Item(a).Text)
                SecHeader = "     " & TreeView1.Nodes(i).Nodes.Item(a).Text
                SecHeaderWritten = False
                If intTableNodeCount > 0 Then
                    For x = 0 To intTableNodeCount - 1

                        If Compare_Data_Database(GetIndex(TreeView1.Nodes(i).Nodes(a).Nodes.Item(x).Text)) Then

                            'strTableName = TreeView1.Nodes(i).Text & " - " & TreeView1.Nodes(i).Nodes.Item(a).Text & " - " & TreeView1.Nodes(i).Nodes(a).Nodes.Item(x).Text

                            If MainHeaderWritten = False Then
                                MainHeaderWritten = True
                                tmpwriter.WriteLine(MainHeader)
                            End If

                            If SecHeaderWritten = False Then
                                SecHeaderWritten = True
                                tmpwriter.WriteLine(SecHeader)
                            End If

                            strTableName = "          " & TreeView1.Nodes(i).Nodes(a).Nodes.Item(x).Text
                            strTableName = strTableName.Replace("_", " ")
                            tmpwriter.WriteLine(strTableName)
                            intTableCount += 1


WaitHere:
                            If Not LoadingData Then
                                'strTable = ExportDataGrid()
                            Else
                                Application.DoEvents()
                                GoTo WaitHere
                            End If

                        End If
                    Next
                    If SecHeaderWritten = True Then tmpwriter.WriteLine(" ")
                Else


                    If Compare_Data_Database(GetIndex(TreeView1.Nodes(i).Nodes.Item(a).Text)) Then

                        If MainHeaderWritten = False Then
                            MainHeaderWritten = True
                            tmpwriter.WriteLine(MainHeader)
                        End If

                        strTableName = "     " & TreeView1.Nodes(i).Nodes.Item(a).Text
                        strTableName = strTableName.Replace("_", " ")
                        tmpwriter.WriteLine(strTableName)
                        intTableCount += 1
                    End If

                End If
            Next
            If MainHeaderWritten = True Then tmpwriter.WriteLine(" ")
        Next

        tmpwriter.Close()

        If Not SuppressPopups Then MsgBox("Finished saving tables to " & vbCrLf & SaveAsPath)

    End Sub

    Private Function Compare_Data_Database(ByVal List_Index As Integer) As Boolean

        Dim resp As Boolean = False

        'Start position - the first 4 characters are the row, the last 1 is the column
        Dim str_Start_Row As String = dsTableData.Tables(0).Rows(List_Index).Item("StartPosition")

        'Number of rows intable
        Dim Row_Count As Integer = Val(dsTableData.Tables(0).Rows(List_Index).Item("RowCount"))
        Dim Column_Count As Integer = Val(dsTableData.Tables(0).Rows(List_Index).Item("ColumnCount"))
        Dim ByteCount As Int16 = Column_Count * Row_Count

        'Number of bits per cell
        Dim Element_Size As Integer = Val(dsTableData.Tables(0).Rows(List_Index).Item("ElementSize"))
        Dim tmpHexString As String, tmpHexString2 As String, str1 As String, str2 As String
        Dim HexPosition As Long = Convert.ToInt32(str_Start_Row, 16)
        Dim ColCounter As Int16, RowCounter As Int16, i As Int16, esCounter As Int16

        resp = False

        For ColCounter = 0 To Column_Count - 1
            For i = 0 To Row_Count - 1
                For esCounter = 1 To Element_Size
                    tmpHexString = Hex(BinaryFile(HexPosition))
                    tmpHexString2 = Hex(LinkedBinaryFile(HexPosition))
                    HexPosition += 1
                    If tmpHexString.Length < 2 Then
                        str1 += "0" & tmpHexString
                    Else
                        str1 += tmpHexString
                    End If

                    If Not LinkedBinary = "" And tmpHexString2.Length < 2 Then
                        str2 += "0" & tmpHexString2
                    Else
                        str2 += tmpHexString2
                    End If

                    If Not str1 = str2 Then
                        resp = True
                    End If
                Next
            Next
        Next


        Return resp

    End Function
    Private Sub AutoSaveDifferencesFilesToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AutoSaveDifferencesFilesToolStripMenuItem.Click
        AutoSaveDifferencesFile = Not AutoSaveDifferencesFilesToolStripMenuItem.Checked
        AutoSaveDifferencesFilesToolStripMenuItem.Checked = AutoSaveDifferencesFile
        SetRecentFiles()
    End Sub

    Private Sub SplitContainer1_SplitterMoved(ByVal sender As System.Object, ByVal e As System.Windows.Forms.SplitterEventArgs) Handles SplitContainer1.SplitterMoved

    End Sub

    Private Sub AlwaysLoadControlBinaryToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AlwaysLoadControlBinaryToolStripMenuItem.Click

    End Sub

    Private Sub IgnoreControlBinaryOSIDNotRecommendedToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles IgnoreControlBinaryOSIDNotRecommendedToolStripMenuItem.Click
        IgnoreControlOSID = Not IgnoreControlBinaryOSIDNotRecommendedToolStripMenuItem.Checked
        IgnoreControlBinaryOSIDNotRecommendedToolStripMenuItem.Checked = IgnoreControlOSID
    End Sub

    Private Sub FileToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles FileToolStripMenuItem.Click

    End Sub

    Private Sub CopyToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CopyToolStripMenuItem.Click
        Clipboard.Clear()
        Clipboard.SetText(ExportSelected)
    End Sub

    Private Sub PasteToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PasteToolStripMenuItem.Click
        ImportSelectedFromClipboard()
    End Sub

    Private Sub FromHPTunerTextFileToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles FromHPTunerTextFileToolStripMenuItem.Click

        'see if we want to enable importing from an HPT exported file
        Dim OFD_Display As String = ""
        Select Case CurrentTablePath
            Case "Spark -> Base Timing -> Bad Fuel Spark"
                OFD_Display = "Import Low Octane Spark Table"
            Case "Spark -> Base Timing -> Good Fuel Spark"
                OFD_Display = "Import High Octane Spark Table"
            Case "Spark -> Base Timing -> Mean Best Torque Spark"
                OFD_Display = "Import Max Torque Timing Table"
            Case "Fuel -> MAF -> MAF Airflow Table"
                OFD_Display = "Import Airflow vs Frequency (MAF) Table"
            Case "Fuel -> MAF -> MAF Table - Airflow vs Frequency"
                OFD_Display = "Import Airflow vs Frequency (MAF) Table"
        End Select

        Dim tmpOFD As New OpenFileDialog
        tmpOFD.Filter = "HPTuner exported file (*.txt)|*.txt"
        tmpOFD.Title = OFD_Display
        tmpOFD.ShowDialog()

        If Not tmpOFD.FileName = "" Then

            Dim tmpArray As Array = Import_HPT_Table(tmpOFD.FileName)
            If Not tmpArray Is Nothing Then
                ImportData(tmpArray, UBound(tmpArray), True)
            End If


        End If

    End Sub

    Private Sub ExportCurrentNodeToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ExportCurrentNodeToolStripMenuItem.Click
        Dim SaveAsDiag As New SaveFileDialog
        SaveAsDiag.Filter = "Text Files (*.txt)|*.txt"
        SaveAsDiag.ShowDialog()

        If Not SaveAsDiag.FileName = "" Then

            Try

                ExportCurrentNode_Database(SaveAsDiag.FileName)

            Catch ex As Exception
                MsgBox(ex.Message)
            End Try

        End If
    End Sub

    Private Sub CopyTableToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CopyTableToolStripMenuItem.Click
        Clipboard.Clear()
        Clipboard.SetText(ExportDataGrid)
    End Sub

    Private Sub PasteTableToolStripMenuItem_AvailableChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles PasteTableToolStripMenuItem.AvailableChanged

    End Sub

    Private Sub PasteTableToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PasteTableToolStripMenuItem.Click
        ImportTableFromClipboard()
    End Sub

    Private Sub AutoSaveTablesStopBiggingMeToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AutoSaveTablesStopBiggingMeToolStripMenuItem.Click
        AutoSaveTables = Not AutoSaveTablesStopBiggingMeToolStripMenuItem.Checked
        AutoSaveTablesStopBiggingMeToolStripMenuItem.Checked = AutoSaveTables
        SetRecentFiles()
    End Sub

    Private Sub DumpDataToDBToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles DumpDataToDBToolStripMenuItem.Click

        Dim cnWriter As OleDb.OleDbConnection
        cnWriter = New OleDb.OleDbConnection("Provider=Microsoft.Jet.OLEDB.4.0;Data Source=TTDB.mdb")
        cnWriter.Open()

        Dim tmpWriter As IO.StreamWriter
        tmpWriter = New IO.StreamWriter("error.log")

        Dim cmdWriter As New OleDb.OleDbCommand
        cmdWriter.Connection = cnWriter

        Dim tt As New TinyTunerDLL.TableLocations
        Dim i As Int16

        Dim tablecounter As Int16
        Dim tmpTableCount As Int16 = tt.GetTableCount(i)
        Dim AllowNegative As Byte = 0
        Dim DisplayWholeNumbers As Byte = 0

        Dim ContinueLoop As Boolean = True
        Dim ContinueAll As Boolean = False

        Try
            For i = 93 To 100
                If Not GetMapSupport(i) = "" Then

                    tmpTableCount = tt.GetTableCount(i)
                    Dim Table_Information As Array = tt.GetTables(i, False)

                    For tablecounter = 1 To tmpTableCount


ContinueOverride:
                        If Not Table_Information(0, tablecounter) Is Nothing Then
                            If Table_Information(0, tablecounter).ToString.ToLower = "yes" Then DisplayWholeNumbers = 1 Else DisplayWholeNumbers = 0
                        End If

                        If Not Table_Information(10, tablecounter) Is Nothing Then
                            If Table_Information(10, tablecounter).ToString.ToLower = "yes" Then AllowNegative = 1 Else AllowNegative = 0
                        End If

                        cmdWriter.CommandText = "Insert into TableData (MapNumber, TableName, StartPosition, ElementSize, Factor, Units, " & _
                                                "DisplayWholeNumbers, AllowNegative, ColumnCount, ColumnHeaders, RowCount, RowHeaders, " & _
                                                "TableDescription, MainCategory, SubCategory) values " & _
                                                "(" & i.ToString & ", " & _
                                                "'" & Table_Information(1, tablecounter) & "', " & _
                                                "'" & Table_Information(2, tablecounter) & "', " & _
                                                Table_Information(3, tablecounter) & ", " & _
                                                Table_Information(4, tablecounter) & ", " & _
                                                "'" & Table_Information(5, tablecounter) & "', " & _
                                                DisplayWholeNumbers & ", " & _
                                                AllowNegative & ", " & _
                                                "'" & Table_Information(6, tablecounter) & "', " & _
                                                "'" & Table_Information(12, tablecounter) & "', " & _
                                                "'" & Table_Information(7, tablecounter) & "', " & _
                                                "'" & Table_Information(13, tablecounter) & "', " & _
                                                "'" & Table_Information(11, tablecounter) & "', " & _
                                                "'" & Table_Information(14, tablecounter) & "', " & _
                                                "'" & Table_Information(15, tablecounter) & "')"

                        Try
                            cmdWriter.ExecuteNonQuery()
                        Catch ex As Exception
                            tmpWriter.WriteLine(ex.Message & vbCrLf & "      i = " & i.ToString & "  TableCounter = " & tablecounter.ToString)
                            If MessageBox.Show("Error filling Access database..." & vbCrLf & vbCrLf & ex.Message & vbCrLf & vbCrLf & "i = " & i.ToString & "  TableCounter = " & tablecounter.ToString & vbCrLf & vbCrLf & "Continue?", "Error", MessageBoxButtons.YesNo) = Windows.Forms.DialogResult.No Then
                                ContinueLoop = False
                            End If
                        End Try

                        If Not ContinueLoop Then Exit Try

                    Next


                End If
            Next
        Catch ex As Exception

            tmpWriter.WriteLine("*** " & ex.Message & vbCrLf & "      i = " & i.ToString & "  TableCounter = " & tablecounter.ToString)
            tmpWriter.WriteLine(cmdWriter.CommandText)
            MessageBox.Show("Error filling Access database..." & vbCrLf & vbCrLf & ex.Message & vbCrLf & vbCrLf & "i = " & i.ToString & "  TableCounter = " & tablecounter.ToString)

        Finally

            tmpWriter.Close()
            cnWriter.Close()

        End Try

    End Sub

    Private Sub UseDatabaseWhenAvailableToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles UseDatabaseWhenAvailableToolStripMenuItem.Click

        UseDatabase = Not UseDatabaseWhenAvailableToolStripMenuItem.Checked
        UseDatabaseWhenAvailableToolStripMenuItem.Checked = UseDatabase
        SetRecentFiles()

        If DatabaseLoaded Then
            InitTreeList(GetMapNumber(Current_OSID))
        End If

    End Sub

    Private Sub SelectDatabaseToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SelectDatabaseToolStripMenuItem.Click

        Dim tmpOpen As New OpenFileDialog
        tmpOpen.Filter = "Access Database (*.mdb)|*.mdb"
        If Not DatabasePath = "" Then
            tmpOpen.Title = "Select Database - " & DatabasePath
            tmpOpen.InitialDirectory = DatabasePath
        End If
        tmpOpen.ShowDialog()

        If Not tmpOpen.FileName = "" Then

            DatabasePath = tmpOpen.FileName

            If UseDatabaseWhenAvailableToolStripMenuItem.Checked Then
                UseDatabase = True
            End If

            SetRecentFiles()

        End If
    End Sub

    Private Sub Compare2BinaryFileToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Compare2BinaryFileToolStripMenuItem.Click
        CompareBinaries()
    End Sub

    Private Sub ViewAllTablesToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ViewAllTablesToolStripMenuItem.Click
        ShowEverything = Not ViewAllTablesToolStripMenuItem.Checked
        ViewAllTablesToolStripMenuItem.Checked = ShowEverything

        SetRecentFiles()

        If BinaryFileLoaded Then InitTreeList(GetMapNumber(Current_OSID))

    End Sub

    Private Sub ExportOSIDStuffToDBToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ExportOSIDStuffToDBToolStripMenuItem.Click

        If DatabasePath = "" Then
            MsgBox("Select a database first!")
            Exit Sub
        End If

        Dim cnWriter As OleDb.OleDbConnection
        cnWriter = New OleDb.OleDbConnection("Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" & DatabasePath)
        cnWriter.Open()

        Dim tmpWriter As IO.StreamWriter
        tmpWriter = New IO.StreamWriter("error.log")

        Dim cmdWriter As New OleDb.OleDbCommand
        cmdWriter.Connection = cnWriter

        Dim tt As New TinyTunerDLL.TableLocations
        Dim i As Int16

        Dim tablecounter As Int16
        Dim tmpTableCount As Int16 = tt.GetTableCount(i)
        Dim AllowNegative As Byte = 0
        Dim DisplayWholeNumbers As Byte = 0

        Dim ContinueLoop As Boolean = True
        Dim ContinueAll As Boolean = False

        Dim tmpArray As Array

        Try
            For i = 10 To 100

                tmpArray = GetMapSupport(i).Split(",")

                If tmpArray.Length > 0 Then

                    For tablecounter = 0 To tmpArray.Length - 1

ContinueOverride:

                        If Not tmpArray(tablecounter) = "" Then
                            cmdWriter.CommandText = "Insert into OSIDData (OSID, MapNumber) values (" & tmpArray(tablecounter) & "," & i & ")"

                            Try
                                cmdWriter.ExecuteNonQuery()
                            Catch ex As Exception
                                tmpWriter.WriteLine(ex.Message & vbCrLf & "      i = " & i.ToString & "  TableCounter = " & tablecounter.ToString)
                                If MessageBox.Show("Error filling Access database..." & vbCrLf & vbCrLf & ex.Message & vbCrLf & vbCrLf & "i = " & i.ToString & "  TableCounter = " & tablecounter.ToString & vbCrLf & vbCrLf & "Continue?", "Error", MessageBoxButtons.YesNo) = Windows.Forms.DialogResult.No Then
                                    ContinueLoop = False
                                End If
                            End Try

                            If Not ContinueLoop Then Exit Try
                        End If

                    Next

                End If
            Next

        Catch ex As Exception

            tmpWriter.WriteLine("*** " & ex.Message & vbCrLf & "      i = " & i.ToString & "  TableCounter = " & tablecounter.ToString)
            tmpWriter.WriteLine(cmdWriter.CommandText)
            MessageBox.Show("Error filling Access database..." & vbCrLf & vbCrLf & ex.Message & vbCrLf & vbCrLf & "i = " & i.ToString & "  TableCounter = " & tablecounter.ToString)

        Finally

            tmpWriter.Close()
            cnWriter.Close()

        End Try

    End Sub

    Private Sub ContextMenuStrip1_Opening_1(ByVal sender As System.Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles ContextMenuStrip1.Opening

        ImportTreeFromLinkedFileToolStripMenuItem.Enabled = EnableTreeMenu

        Try
            If TreeView1.SelectedNode.Nodes.Count = 0 Then
                If UseDatabase Then
                    AddToTableToolStripMenuItem.Enabled = True
                End If
            Else
                AddToTableToolStripMenuItem.Enabled = False
            End If
        Catch ex As Exception

        End Try
        

    End Sub

    Private Sub ImportTreeFromLinkedFileToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ImportTreeFromLinkedFileToolStripMenuItem.Click

        If MessageBox.Show("Are you sure you want to import the data for this section from the linked binary file?", "", MessageBoxButtons.YesNo) = Windows.Forms.DialogResult.Yes Then
            ImportSelectedNodeTree()
        End If

    End Sub


    Private Sub ImportNodeData(ByVal MainNodeIndex As Integer, ByVal SubNodeIndex As Integer)

        Dim TableNodeCount As Integer = TreeView1.Nodes(MainNodeIndex).Nodes(SubNodeIndex).Nodes.Count
        Dim BottomNodeIndex As Integer
        Dim TableName As String

        If TableNodeCount > 0 Then
            LoadingData = True
            For BottomNodeIndex = 0 To TableNodeCount - 1
                TableName = TreeView1.Nodes(MainNodeIndex).Nodes(SubNodeIndex).Nodes(BottomNodeIndex).Text
                TreeView1.SelectedNode = TreeView1.Nodes(MainNodeIndex).Nodes(SubNodeIndex).Nodes(BottomNodeIndex)
                Convert_Data_Database(TableName, False, True)
                If DatabaseLoaded Then Save_Grid_Database() Else Save_Grid()
                GridChanged = False
            Next BottomNodeIndex
            LoadingData = False
        End If

    End Sub

    Private Sub ImportSelectedNodeTree()

        If LinkedBinaryFileLoaded Then

            If Not LoadingData Then

                If DatabaseLoaded Then
                    Dim strCat As String = "", strTable As String = ""

                    Dim MainNodeIndex As Int16 = 0
                    Dim SubNodeIndex As Int16 = 0

                    Dim i As Int16, a As Int16, x As Int16
                    If TreeView1.SelectedNode.Level = 1 Then
                        MainNodeIndex = TreeView1.SelectedNode.Parent.Index
                        SubNodeIndex = TreeView1.SelectedNode.Index
                        ImportNodeData(MainNodeIndex, TreeView1.SelectedNode.Index)
                    Else
                        'ImportSubnodes(TreeView1.SelectedNode.Index)
                    End If

                Else

                    'Convert_Data(GetNodeIndex(TreeView1.SelectedNode.Text), True)
                    MessageBox.Show("Need to code this non-database option")

                End If

            End If
        End If

        MessageBox.Show("Finished importing tables from the linked file.", "Finished!", MessageBoxButtons.OK)

    End Sub
    Private Sub TreeView1_MouseClick(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles TreeView1.MouseClick

        
    End Sub

    Private Sub FillToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)

    End Sub

    Private Sub CopyOSIDDataToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CopyOSIDDataToolStripMenuItem.Click
        If DatabasePath = "" Then
            MsgBox("Select a database first!")
            Exit Sub
        End If

        Dim cn As OleDb.OleDbConnection
        cn = New OleDb.OleDbConnection("Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" & DatabasePath)
        cn.Open()

        Dim tmpWriter As IO.StreamWriter
        tmpWriter = New IO.StreamWriter("OSIDerror.log")

        Dim cmd As New OleDb.OleDbCommand
        cmd.Connection = cn

        Dim tt As New TinyTunerDLL.TableLocations
        Dim i As Long

        Dim tablecounter As Int16
        Dim tmpTableCount As Int16 = tt.GetTableCount(i)
        Dim AllowNegative As Byte = 0
        Dim DisplayWholeNumbers As Byte = 0

        Dim ContinueLoop As Boolean = True
        Dim ContinueAll As Boolean = False

        Dim tmpArray(8) As String
        Dim tmpString As String = ""
        Dim AddIt As Boolean = False
        Dim a As Int16 = 0
        Dim ThisMapNumber As Int16 = 0

        Try
            For i = 9352680 To 16269002   '9393582
                'For i = 12201440 To 12600200
                'For i = 16243643 To 16269000

                Me.Text = "Searching Number " & i.ToString
                Me.Refresh()

                Application.DoEvents()

                tmpString = tt.GetParameters(i, 1)
                If Not tmpString = "" Then

                    cmd.CommandText = "Select * from OSIDData where OSID=" & i
                    If cmd.ExecuteScalar = 0 Then AddIt = True Else AddIt = False

                    For a = 1 To 8
                        tmpArray(a) = tt.GetParameters(i, a)
                    Next


                    If AddIt Then
                        ThisMapNumber = GetMapNumberFromDatabase(i)
                        cmd.CommandText = "Insert into OSIDData (OSID, MAPNumber, FlashCRC, OSIDLoc, MBTSLoc, GFSLoc, MAFLoc, VELoc, VERowCount, YearModel) values (" & _
                                            i.ToString & ", " & ThisMapNumber & ", '" & _
                                          tmpArray(1) & "', '" & tmpArray(2) & "', '" & tmpArray(3) & "', '" & tmpArray(4) & "', '" & tmpArray(5) & _
                                          "', '" & tmpArray(6) & "', '" & tmpArray(7) & "', '" & tmpArray(8) & "')"
                    Else
                        cmd.CommandText = "UPDATE OSIDData SET " & _
                                        "FlashCRC='" & tmpArray(1) & "', " & _
                                        "OSIDLoc='" & tmpArray(2) & "', " & _
                                        "MBTSLoc='" & tmpArray(4) & "', " & _
                                        "GFSLoc='" & tmpArray(5) & "', " & _
                                        "MAFLoc='" & tmpArray(6) & "', " & _
                                        "VELoc='" & tmpArray(7) & "', " & _
                                        "VERowCount='" & tmpArray(8) & "', " & _
                                        "YearModel='" & tmpArray(3) & "' " & _
                                        "WHERE OSID=" & i.ToString


                    End If

                    'cmd.ExecuteNonQuery()

                    'cmd.CommandText = "Insert into OSIDData (OSID, MapNumber) values (" & tmpArray(tablecounter) & "," & i & ")"

                    Try
                        cmd.ExecuteNonQuery()
                    Catch ex As Exception
                        tmpWriter.WriteLine(ex.Message & vbCrLf & "      i = " & i.ToString & "  TableCounter = " & tablecounter.ToString)
                        If MessageBox.Show("Error filling Access database..." & vbCrLf & vbCrLf & ex.Message & vbCrLf & vbCrLf & "i = " & i.ToString & "  TableCounter = " & tablecounter.ToString & vbCrLf & vbCrLf & "Continue?", "Error", MessageBoxButtons.YesNo) = Windows.Forms.DialogResult.No Then
                            ContinueLoop = False
                        End If
                    End Try

                    If Not ContinueLoop Then Exit Try
                End If

            Next

        Catch ex As Exception

            tmpWriter.WriteLine("*** " & ex.Message & vbCrLf & "      i = " & i.ToString & "  TableCounter = " & tablecounter.ToString)
            tmpWriter.WriteLine(cmd.CommandText)
            MessageBox.Show("Error filling Access database..." & vbCrLf & vbCrLf & ex.Message & vbCrLf & vbCrLf & "i = " & i.ToString & "  TableCounter = " & tablecounter.ToString)

        Finally

            tmpWriter.Close()
            cn.Close()

        End Try
    End Sub

    Private Sub OptionsToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OptionsToolStripMenuItem.Click

    End Sub

    Private Sub ToolsToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolsToolStripMenuItem.Click
        Compare2BinaryFileToolStripMenuItem.Enabled = DatabaseIsAvailable  'UseDatabase
    End Sub

    Private Sub AddToGridToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AddToGridToolStripMenuItem.Click
        AddToGridToolStripMenuItem.Checked = Not AddToGridToolStripMenuItem.Checked

        If Not AddToGridToolStripMenuItem.Checked Then
            TreeView1.BackColor = TextBox1.BackColor
        Else
            TreeView1.BackColor = Color.Cyan
        End If
    End Sub

    Private Sub ExportCurentNodeListToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ExportCurentNodeListToolStripMenuItem.Click
        Dim SaveAsDiag As New SaveFileDialog
        SaveAsDiag.Filter = "Text Files (*.txt)|*.txt"
        SaveAsDiag.ShowDialog()

        If Not SaveAsDiag.FileName = "" Then

            Try

                ExportCurrentNode_Database(SaveAsDiag.FileName, True)

            Catch ex As Exception
                MsgBox(ex.Message)
            End Try

        End If
    End Sub

    Private Sub ShowShiftPointsToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)


    End Sub

    Private Sub Show293ShiftPoints()
        TextBox1.WordWrap = False
        TextBox1.Text = "RPM	1st Gear       2nd Gear     3rd Gear     4th Gear" & vbCrLf & _
                        "===============================================" & vbCrLf & _
                        "1000	8.42    	    15.66	    24.59	    34.63" & vbCrLf & _
                        "2000	16.84	    31.32	    49.18	    69.27" & vbCrLf & _
                        "3000	25.26	    46.99	    73.78	    103.91" & vbCrLf & _
                        "3200	26.95               50.13	    78.70	    110.85" & vbCrLf & _
                        "3400	28.64	    53.26	    83.62	    117.77" & vbCrLf & _
                        "3600	30.32	    56.39	    88.54	    124.70" & vbCrLf & _
                        "3800	32.01	    59.53	    93.46	    131.63" & vbCrLf & _
                        "4000	33.69	    62.66	    98.38	    138.56" & vbCrLf & _
                        "4200	35.37	    65.79	    103.29	    145.49" & vbCrLf & _
                        "4400	37.06	    68.93	    108.21	    152.41" & vbCrLf & _
                        "4600	38.74	    72.06	    113.13	    159.34" & vbCrLf & _
                        "4800	40.43	    75.19	    118.05         166.27" & vbCrLf & _
                        "5000	42.11	    78.32	    122.97	    173.20" & vbCrLf & _
                        "5100	42.96	    79.89	    125.43	    176.66" & vbCrLf & _
                        "5200	43.80	    81.46	    127.89	    180.13" & vbCrLf & _
                        "5300	44.64	    83.02	    130.35	    183.59" & vbCrLf & _
                        "5400	45.48	    84.59	    132.81	    187.05" & vbCrLf & _
                        "5500	46.32	    86.15	    135.26	    190.51" & vbCrLf & _
                        "5600	47.16	    87.72	    137.72	    193.98" & vbCrLf & _
                        "5700	48.00	    89.29	    140.18	    197.44" & vbCrLf & _
                        "5800	48.85	    90.85	    142.64	    200.90" & vbCrLf & _
                        "5900	49.69	    92.42	    145.10	    204.37" & vbCrLf & _
                        "6000	50.53	    93.98	    147.56	    207.83" & vbCrLf & _
                        "6100	51.37	    95.55	    150.02	    211.30" & vbCrLf & _
                        "6200	52.22	    97.12	    152.48	    214.76" & vbCrLf & _
                        "6300	53.06	    98.68	    154.94	    218.22" & vbCrLf & _
                        "6400	53.90	    100.25	    157.40	    221.69" & vbCrLf & _
                        "6500	54.74	    101.82	    159.86	    225.15" & vbCrLf & _
                        "6600	55.58	    103.38	    162.32	    228.62" & vbCrLf & _
                        "6700	56.43	    104.95	    164.77	    232.08" & vbCrLf & _
                        "6800	57.27	    106.52	    167.23	    235.54" & vbCrLf & _
                        "6900	58.11	    108.08	    169.69        239.01" & vbCrLf & _
                        "7000	58.95	    109.65	    172.15	   242.47"
    End Sub
    Private Sub Show392ShiftPoints()
        TextBox1.WordWrap = False
        TextBox1.Text = "RPM	1st Gear	2nd Gear	3rd Gear	4th Gear" & vbCrLf & _
                        "===================================================" & vbCrLf & _
                        "1000	7.50    	13.95   	21.90   	30.84" & vbCrLf & _
                        "2000	15.00   	27.90   	43.80   	61.69" & vbCrLf & _
                        "3000	22.50   	41.85   	65.70   	92.54" & vbCrLf & _
                        "4000	30.00   	55.80   	87.60   	123.39" & vbCrLf & _
                        "5000	37.50   	69.75   	109.54  	154.23" & vbCrLf & _
                        "5500	41.25   	76.72   	120.46  	169.66" & vbCrLf & _
                        "5600	42.00   	78.12   	122.65  	172.74" & vbCrLf & _
                        "5700	42.75   	79.51   	124.84  	175.83" & vbCrLf & _
                        "5800	43.50   	80.91   	127.03  	178.91" & vbCrLf & _
                        "5900	44.25   	82.30   	129.22  	182.00" & vbCrLf & _
                        "6000	45.00   	83.70   	131.41  	185.08" & vbCrLf & _
                        "6100	45.75   	85.09   	133.60  	188.17" & vbCrLf & _
                        "6200	46.50   	86.49   	135.79  	191.25" & vbCrLf & _
                        "6300	47.25   	87.88   	137.98  	194.34" & vbCrLf & _
                        "6400	48.00   	89.28   	140.17  	197.42" & vbCrLf & _
                        "6500	48.75   	90.67   	142.36        200.51" & vbCrLf & _
                        "6600	49.50   	92.07   	144.55  	203.59" & vbCrLf & _
                        "6700	50.25   	93.46   	146.74  	206.67" & vbCrLf & _
                        "6800	51.00   	94.86   	148.93  	209.76" & vbCrLf & _
                        "6900	51.75   	96.25   	151.12  	212.84" & vbCrLf & _
                        "7000	52.50   	97.65   	153.31  	215.93"

    End Sub

    Private Sub RPMVsMPHChartToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RPMVsMPHChartToolStripMenuItem.Click
        If Not RPMVsMPHChartToolStripMenuItem.Checked Then
            Show293ShiftPoints()
            RPMVsMPHChartToolStripMenuItem.Checked = True
            RPMVsMPHChartToolStripMenuItem1.Checked = False
            DisplayDescription = False
        Else
            RPMVsMPHChartToolStripMenuItem.Checked = False
            DisplayDescription = True
        End If
    End Sub

    Private Sub RPMVsMPHChartToolStripMenuItem1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RPMVsMPHChartToolStripMenuItem1.Click
        If Not RPMVsMPHChartToolStripMenuItem1.Checked Then
            Show392ShiftPoints()
            RPMVsMPHChartToolStripMenuItem.Checked = False
            RPMVsMPHChartToolStripMenuItem1.Checked = True
            DisplayDescription = False
        Else
            RPMVsMPHChartToolStripMenuItem1.Checked = False
            DisplayDescription = True
        End If
    End Sub
    Private Sub SetStatusBarVisibilityMenuItems()


        Dim i As Int16
        Dim strStatusBarFlag As String = Convert.ToString(StatusBarDisplayFlags, 2)

        If strStatusBarFlag.Length < 5 Then
            For i = 0 To 4 - strStatusBarFlag.Length
                strStatusBarFlag = "0" & strStatusBarFlag
            Next
        End If

        If strStatusBarFlag.Substring(0, 1) = "1" Then
            ShowOSIDToolStripMenuItem.Checked = True
            ToolStripStatusLabel2.Visible = True
        Else
            ShowOSIDToolStripMenuItem.Checked = False
            ToolStripStatusLabel2.Visible = False
        End If

        If strStatusBarFlag.Substring(1, 1) = "1" Then
            ShowTemplateNumberToolStripMenuItem.Checked = True
            ToolStripStatusLabel7.Visible = True
        Else
            ShowTemplateNumberToolStripMenuItem.Checked = False
            ToolStripStatusLabel7.Visible = False
        End If

        If strStatusBarFlag.Substring(2, 1) = "1" Then
            ShowTableCountToolStripMenuItem.Checked = True
            ToolStripStatusLabel4.Visible = True
        Else
            ShowTableCountToolStripMenuItem.Checked = False
            ToolStripStatusLabel4.Visible = False
        End If

        If strStatusBarFlag.Substring(3, 1) = "1" Then
            ShowVINToolStripMenuItem.Checked = True
            ToolStripStatusLabel5.Visible = True
        Else
            ShowVINToolStripMenuItem.Checked = False
            ToolStripStatusLabel5.Visible = False
        End If

        If strStatusBarFlag.Substring(4, 1) = "1" Then
            ShowSerialNumberToolStripMenuItem.Checked = True
            ToolStripStatusLabel6.Visible = True
        Else
            ShowSerialNumberToolStripMenuItem.Checked = False
            ToolStripStatusLabel6.Visible = False
        End If


    End Sub

    Private Sub SetStatusBarLableVisibility()

    End Sub
    Private Sub SaveStatusBarFlags()

        Dim strStatusBarFlag As String = ""
        Dim tmpValue As String = ""

        'Show OSID?
        If ShowOSIDToolStripMenuItem.Checked Then
            tmpValue = "1"
        Else
            tmpValue = "0"
        End If
        strStatusBarFlag += tmpValue

        'Show Template Number?
        If ShowTemplateNumberToolStripMenuItem.Checked Then
            tmpValue = "1"
        Else
            tmpValue = "0"
        End If
        strStatusBarFlag += tmpValue

        'Show table count
        If ShowTableCountToolStripMenuItem.Checked Then
            tmpValue = "1"
        Else
            tmpValue = "0"
        End If
        strStatusBarFlag += tmpValue

        'Show VIN
        If ShowVINToolStripMenuItem.Checked Then
            tmpValue = "1"
        Else
            tmpValue = "0"
        End If
        strStatusBarFlag += tmpValue

        'Show Serial Number
        If ShowSerialNumberToolStripMenuItem.Checked Then
            tmpValue = "1"
        Else
            tmpValue = "0"
        End If
        strStatusBarFlag += tmpValue

        Debug.Print(strStatusBarFlag)
        StatusBarDisplayFlags = Convert.ToSByte(strStatusBarFlag, 2)

        SetRecentFiles()

        SetStatusBarVisibilityMenuItems()

    End Sub

    Private Sub ShowOSIDToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ShowOSIDToolStripMenuItem.Click
        ShowOSIDToolStripMenuItem.Checked = Not ShowOSIDToolStripMenuItem.Checked
        SaveStatusBarFlags()
    End Sub

    Private Sub ShowTemplateNumberToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ShowTemplateNumberToolStripMenuItem.Click
        ShowTemplateNumberToolStripMenuItem.Checked = Not ShowTemplateNumberToolStripMenuItem.Checked
        SaveStatusBarFlags()
    End Sub

    Private Sub ShowTableCountToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ShowTableCountToolStripMenuItem.Click
        ShowTableCountToolStripMenuItem.Checked = Not ShowTableCountToolStripMenuItem.Checked
        SaveStatusBarFlags()
    End Sub

    Private Sub ShowVINToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ShowVINToolStripMenuItem.Click
        ShowVINToolStripMenuItem.Checked = Not ShowVINToolStripMenuItem.Checked
        SaveStatusBarFlags()
    End Sub

    Private Sub ShowSerialNumberToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ShowSerialNumberToolStripMenuItem.Click
        ShowSerialNumberToolStripMenuItem.Checked = Not ShowSerialNumberToolStripMenuItem.Checked
        SaveStatusBarFlags()
    End Sub
End Class
