Imports microsoft.Win32
Module TinyTunerModule

    Public CurrentVersion As Single

    Public StatusBarDisplayFlags As Byte = 31 '31 = 11111 = show all 5 status bar labels

    Public DatabasePath As String = "None"
    Public DatabaseIsAvailable As Boolean = False
    Public UseDatabase As Boolean
    
    Public HighSparkScale As Boolean = False

    Public BinaryFile() As Byte
    Public LinkedBinaryFile() As Byte

    Public BinaryFileLoaded As Boolean = False
    Public LinkedBinaryFileLoaded As Boolean = False

    Public LastBinLocation As String
    Public Current_OSID As String
    Public CurrentMapNumber As Int16
    Public TableCount As Integer

    Public ExportFolder As String = " "
    Public ImportFolder As String = " "
    Public BinaryFolder As String = " "

    Public SetFolderOnImport As Boolean = False
    Public AutoSaveDifferencesFile As Boolean = False
    Public SuppressPopups As Boolean
    Public IgnoreControlOSID As Boolean = False
    Public AutoSaveTables As Boolean = False

    Public ErrorCount As Integer

    Public pubCategoryList(40, 2) As String
    Public pubCategoryCount As Integer

    Public Recent_Files(5) As String
    Public LinkedBinary As String
    Public UseGridColors As Boolean = False

    Public AvailableTables(1, 1) As String  'Public AvailableTables(16, 50) As String  'Table_Information(14, 1)
    Public SupportedMaps() As String



    Sub Main(ByVal cmdargs() As String)

        CurrentVersion = Val(Application.ProductVersion.Substring(0, 3))

        Dim fForm As New frmTinyTuner
        fForm.Show()
        fForm.Refresh()

        If cmdargs.Length > 0 Then
            If cmdargs(0).Substring(cmdargs(0).Length - 3, 3).ToLower = "bin" Then
                fForm.LoadFile(cmdargs(0), True)
            Else
                MessageBox.Show("The only command line arguments available are a path to a binary file." & vbCrLf & vbCrLf & _
                                "The command line argument supplied was not valid..." & vbCrLf & cmdargs(0), "Invalid Command Argument", MessageBoxButtons.OK, MessageBoxIcon.Error)
            End If
        End If

        Application.Run()

    End Sub

    Private Sub CreateRegistryFolder()

        Dim key As RegistryKey = Registry.CurrentUser.OpenSubKey("Software", True)
        Dim NewKey As RegistryKey = key.CreateSubKey("TinyTuner")
        NewKey.SetValue("File1", "")
        NewKey.SetValue("File2", "")
        NewKey.SetValue("File3", "")
        NewKey.SetValue("File4", "")
        NewKey.SetValue("File5", "")
        NewKey.SetValue("LinkedBinary", "")
        NewKey.SetValue("UseGridColors", False)

    End Sub

    Public Function VerifyRecentFile(ByVal FileName As String)

        Dim OKToAdd As Boolean = True
        Dim i As Int16
        For i = 0 To 4
            If Recent_Files(i) = FileName Then OKToAdd = False
        Next

        If OKToAdd Then
            Recent_Files(4) = Recent_Files(3)
            Recent_Files(3) = Recent_Files(2)
            Recent_Files(2) = Recent_Files(1)
            Recent_Files(1) = Recent_Files(0)
            Recent_Files(0) = FileName
        End If

        Return OKToAdd

    End Function
    Sub SetRecentFiles()

        Dim pRegKey As RegistryKey = My.Computer.Registry.CurrentUser.OpenSubKey("Software\\TinyTuner", True)

        If Not Recent_Files(0) Is Nothing Then pRegKey.SetValue("File1", Recent_Files(0))
        If Not Recent_Files(1) Is Nothing Then pRegKey.SetValue("File2", Recent_Files(1))
        If Not Recent_Files(2) Is Nothing Then pRegKey.SetValue("File3", Recent_Files(2))
        If Not Recent_Files(3) Is Nothing Then pRegKey.SetValue("File4", Recent_Files(3))
        If Not Recent_Files(4) Is Nothing Then pRegKey.SetValue("File5", Recent_Files(4))

        pRegKey.SetValue("LinkedBinary", LinkedBinary)
        pRegKey.SetValue("UseGridColors", UseGridColors)

        If ExportFolder = Nothing Then ExportFolder = Application.StartupPath
        If Not System.IO.Directory.Exists(ExportFolder) Then ExportFolder = Application.StartupPath
        pRegKey.SetValue("ExportFolder", ExportFolder)

        If ImportFolder = Nothing Then ImportFolder = Application.StartupPath
        pRegKey.SetValue("ImportFolder", ImportFolder)

        If BinaryFolder = Nothing Then BinaryFolder = Application.StartupPath
        pRegKey.SetValue("BinaryFolder", BinaryFolder)

        pRegKey.SetValue("SetFolderOnImport", SetFolderOnImport)
        pRegKey.SetValue("SuppressPopups", SuppressPopups)
        pRegKey.SetValue("AutoSaveDifferencesFile", AutoSaveDifferencesFile)
        pRegKey.SetValue("AutoSaveTables", AutoSaveTables)


        'Database related
        pRegKey.SetValue("UseDatabase", UseDatabase)
        If Not DatabasePath = Nothing Then
            pRegKey.SetValue("DatabasePath", DatabasePath)
        End If
        pRegKey.SetValue("ShowEverything", ShowEverything)
        pRegKey.SetValue("StatusBarDisplayFlags", StatusBarDisplayFlags)

    End Sub
    Private Sub SetRecentFileList()



        Dim pRegKey As RegistryKey = My.Computer.Registry.CurrentUser.OpenSubKey("Software\\TinyTuner", True)

        'MessageBox.Show("SetRecentFileList - Try to set reg values")
        Try
            If Not Recent_Files(0) Is Nothing Then pRegKey.SetValue("File1", Recent_Files(0))
            If Not Recent_Files(1) Is Nothing Then pRegKey.SetValue("File2", Recent_Files(1))
            If Not Recent_Files(2) Is Nothing Then pRegKey.SetValue("File3", Recent_Files(2))
            If Not Recent_Files(3) Is Nothing Then pRegKey.SetValue("File4", Recent_Files(3))
            If Not Recent_Files(4) Is Nothing Then pRegKey.SetValue("File5", Recent_Files(4))
        Catch ex As Exception
            MessageBox.Show("Error in SetRecentFilesList Routine" & vbCrLf & vbCrLf & ex.Message)
        End Try

    End Sub
    Sub GetRecentFiles()

        Dim ErrorStep As Integer = 0
        Dim nFileNumber As Int16 = 0
        Dim tmpString As String

        Try

            Dim pRegKey As RegistryKey = My.Computer.Registry.CurrentUser.OpenSubKey("Software\\TinyTuner", False)
            Dim MissingFiles As Boolean = False

            'MessageBox.Show("GetRecentFiles - Check registry File 1")
            'Recent files for 'File' menu
            ErrorStep += 1  '1
            tmpString = pRegKey.GetValue("File1").ToString
            If IO.File.Exists(tmpString) Then
                Recent_Files(nFileNumber) = tmpString
                nFileNumber += 1
            Else
                If tmpString <> "" Then MissingFiles = True
            End If

            'MessageBox.Show("GetRecentFiles - Check registry File 2")
            ErrorStep += 1  '2
            tmpString = pRegKey.GetValue("File2").ToString
            If IO.File.Exists(tmpString) Then
                Recent_Files(nFileNumber) = tmpString
                nFileNumber += 1
            Else
                If tmpString <> "" Then MissingFiles = True
            End If

            'MessageBox.Show("GetRecentFiles - Check registry File 3")
            ErrorStep += 1  '3
            tmpString = pRegKey.GetValue("File3").ToString
            If IO.File.Exists(tmpString) Then
                Recent_Files(nFileNumber) = tmpString
                nFileNumber += 1
            Else
                If tmpString <> "" Then MissingFiles = True
            End If

            'MessageBox.Show("GetRecentFiles - Check registry File 4")
            ErrorStep += 1  '4
            tmpString = pRegKey.GetValue("File4").ToString
            If IO.File.Exists(tmpString) Then
                Recent_Files(nFileNumber) = tmpString
                nFileNumber += 1
            Else
                If tmpString <> "" Then MissingFiles = True
            End If

            'MessageBox.Show("GetRecentFiles - Check registry File 5")
            ErrorStep += 1  '5
            tmpString = pRegKey.GetValue("File5").ToString
            If IO.File.Exists(tmpString) Then
                Recent_Files(nFileNumber) = tmpString
            Else
                If tmpString <> "" Then MissingFiles = True
            End If

            If MissingFiles Then
                'MessageBox.Show("SetRecentFileList")
                SetRecentFileList()
            End If


            'MessageBox.Show("GetRecentFiles - Check registry LinkedBinary")
            ErrorStep += 1  '6
            LinkedBinary = pRegKey.GetValue("LinkedBinary").ToString

            'MessageBox.Show("GetRecentFiles - Check registry UseGridColors")
            ErrorStep += 1  '7
            UseGridColors = pRegKey.GetValue("UseGridColors")

            'MessageBox.Show("GetRecentFiles - Check registry ExportFolder")
            ErrorStep += 1  '8
            ExportFolder = pRegKey.GetValue("ExportFolder")

            ErrorStep += 1  '9
            ImportFolder = pRegKey.GetValue("ImportFolder")

            ErrorStep += 1  '10
            BinaryFolder = pRegKey.GetValue("BinaryFolder")

            ErrorStep += 1  '11
            SetFolderOnImport = pRegKey.GetValue("SetFolderOnImport")

            ErrorStep += 1  '12
            SuppressPopups = pRegKey.GetValue("SuppressPopups")

            ErrorStep += 1 '13
            AutoSaveDifferencesFile = pRegKey.GetValue("AutoSaveDifferencesFile")

            ErrorStep += 1 '14
            AutoSaveTables = pRegKey.GetValue("AutoSaveTables")

            ErrorStep += 1 '15
            UseDatabase = pRegKey.GetValue("UseDatabase")

            ErrorStep += 1 '16
            DatabasePath = pRegKey.GetValue("DatabasePath")

            ErrorStep += 1 '17
            ShowEverything = pRegKey.GetValue("ShowEverything")

            ErrorStep += 1 '18
            StatusBarDisplayFlags = pRegKey.GetValue("StatusBarDisplayFlags")

            '

            ErrorStep = 100

        Catch ex As Exception
            If ErrorCount < 2 Then

                'MessageBox.Show("GetRecentFiles - Add Registry Key - ErrorStep = " & ErrorStep.ToString)
                Dim key As RegistryKey = Registry.CurrentUser.OpenSubKey("Software", True)
                Dim NewKey As RegistryKey = key.CreateSubKey("TinyTuner")
                Select Case ErrorStep
                    Case 1
                        NewKey.SetValue("File1", "")
                    Case 2
                        NewKey.SetValue("File2", "")
                    Case 3
                        NewKey.SetValue("File3", "")
                    Case 4
                        NewKey.SetValue("File4", "")
                    Case 5
                        NewKey.SetValue("File5", "")
                    Case 6
                        NewKey.SetValue("LinkedBinary", "")
                    Case 7
                        NewKey.SetValue("UseGridColors", False)
                    Case 8
                        NewKey.SetValue("ExportFolder", Application.StartupPath)
                    Case 9
                        NewKey.SetValue("ImportFolder", Application.StartupPath)
                    Case 10
                        NewKey.SetValue("BinaryFolder", Application.StartupPath)
                    Case 11
                        NewKey.SetValue("SetFolderOnImport", False)
                    Case 12
                        NewKey.SetValue("SuppressPopups", False)
                    Case 13
                        NewKey.SetValue("AutoSaveDifferencesFile", False)
                    Case 14
                        NewKey.SetValue("AutoSaveTables", False)
                    Case 15
                        NewKey.SetValue("UseDatabase", False)
                    Case 16
                        NewKey.SetValue("DatabasePath", "")
                    Case 17
                        NewKey.SetValue("ShowEverything", False)
                    Case 18
                        NewKey.SetValue("StatusBarDisplayFlags", "11111")
                    Case 100
                        MsgBox("Error with registry settings...")
                End Select

                'CreateRegistryFolder()
                GetRecentFiles()
            Else
                MessageBox.Show(ex.Message)
            End If
        End Try

        If IO.File.Exists(DatabasePath) Then
            DatabaseIsAvailable = True
        Else
            DatabaseIsAvailable = False
            UseDatabase = False
        End If

    End Sub

    Public Enum TP  'Table Parameter
        DisplayWholeNumbers = 0
        Table_Name = 1
        Start_Position = 2
        Element_Size = 3
        Factor = 4
        Units = 5
        Column_Count = 6
        Row_Count = 7
        Row_Header_Step = 8
        Row_Header_Start = 9
        AllowNegative = 10
        Table_Description = 11
        Table_Column_Headers = 12
        Table_Row_Headers = 13
        Main_Category = 14
        Sub_Category = 15
    End Enum

    Public Enum RT  'RetrieveType
        FlashCRC = 1
        OSIDLoc = 2
        YearModel = 3
        MBTSLoc = 4
        GFSLoc = 5
        MAFLoc = 6
        VELoc = 7
        VERowCount = 8
    End Enum

    Public Function ImportBinaryFile(ByVal File_Name As String) As Boolean

        Try
            Dim fs As New IO.FileStream(File_Name, IO.FileMode.Open, IO.FileAccess.Read)
            Dim r As New IO.BinaryReader(fs)
            Dim File_Info As New IO.FileInfo(File_Name)

            BinaryFileLoaded = False
            ReDim BinaryFile(File_Info.Length - 1)

            Dim ErrorStep As Integer

            Dim retval As Boolean = True
            Try
                Dim i As Integer
                For i = 0 To File_Info.Length - 1
                    BinaryFile(i) = r.ReadByte
                Next

                fs.Close()
                r.Close()
            Catch ex As Exception
                retval = False
                MsgBox("Error importing primary binary file." & vbCrLf & vbCrLf & ex.Message)
            End Try

            If Not LinkedBinary = "" And retval Then
                If IO.File.Exists(LinkedBinary) Then
                    'ImportLinkedBinary()
                Else
                    MessageBox.Show("The linked binary file does not exist." & vbCrLf & vbCrLf & "Path - " & LinkedBinary, "File Not Found", MessageBoxButtons.OK, MessageBoxIcon.Information)
                    LinkedBinary = ""
                    UseGridColors = False
                    SetRecentFiles()
                End If
            End If

            Return retval

        Catch ex As Exception
            MsgBox("Error loading binary file." & vbCrLf & vbCrLf & ex.Message)
            Return False
        End Try



    End Function
    Public Function ImportLinkedBinary() As Boolean

        If Not IgnoreControlOSID Then

            Dim LinkedMapNumner As Int16
            If Not UseDatabase Then
                Dim tt As New TinyTunerDLL.TableLocations
                LinkedMapNumner = GetMapNumber(Get_OSID(LinkedBinary))
            Else
                LinkedMapNumner = GetMapNumberFromDatabase(Get_OSID(LinkedBinary))
            End If

            If Not LinkedMapNumner = CurrentMapNumber Then  'GetMapNumber(Current_OSID) Then

                If Not SuppressPopups Then
                    MessageBox.Show("The MAP number for the linked file does not match the imported binary." & vbCrLf & vbCrLf & _
                          "Can not use the linked file...", "Incorrect MAP", MessageBoxButtons.OK, MessageBoxIcon.Error)
                End If

                LinkedBinary = ""
                LinkedBinaryFileLoaded = False
                Exit Function

            End If
        End If



        Dim fs As New IO.FileStream(LinkedBinary, IO.FileMode.Open, IO.FileAccess.Read)
        Dim r As New IO.BinaryReader(fs)
        Dim File_Info As New IO.FileInfo(LinkedBinary)

        ReDim LinkedBinaryFile(File_Info.Length - 1)

        Dim ErrorStep As Integer

        Dim retval As Boolean = True
        Try
            Dim i As Integer
            For i = 0 To File_Info.Length - 1
                LinkedBinaryFile(i) = r.ReadByte
            Next

        Catch ex As Exception
            retval = False
            MsgBox("Error importing control binary file." & vbCrLf & vbCrLf & ex.Message)
        End Try

        If retval = True Then LinkedBinaryFileLoaded = True

        Return retval

    End Function

    Public Function Get_OSID(ByVal File_Name As String) As String

        Dim retVal As Int32 = 0

        Try
            Dim fs As New IO.FileStream(File_Name, IO.FileMode.Open, IO.FileAccess.Read)

            Dim r As New IO.BinaryReader(fs)
            Dim mFile_Info As New IO.FileInfo(File_Name)

            Dim OSID As String = ""

            Dim OSID_String1 As String = ""
            Dim OSID_String2 As String = ""
            Dim Use_OSID As String = ""
            Dim tmpBinaryValue As String = ""

            Dim CellValue As String = ""
            Dim i As Integer = 0
            Dim c1 As Integer
            Dim c2 As Integer

            For i = 0 To mFile_Info.Length - 1

                tmpBinaryValue = CellValue
                CellValue = Hex(r.ReadByte)

                If CellValue.Length < 2 Then
                    CellValue = "0" & CellValue
                End If

                tmpBinaryValue += CellValue

                If i > (mFile_Info.Length - 6) And c1 < 3 Then
                    OSID_String1 += CellValue
                    c1 += 1
                End If
                If i > (mFile_Info.Length - 8) And c2 < 3 Then
                    OSID_String2 += CellValue
                    c2 += 1
                End If
            Next

            fs.Close()
            r.Close()

            If tmpBinaryValue = "FFFF" Or tmpBinaryValue = "0000" Then
                retVal = Convert.ToInt32(OSID_String2, 16)
            Else
                retVal = Convert.ToInt32(OSID_String1, 16)
            End If

        Catch ex As Exception

            MessageBox.Show("An error occured loading the binary file." & vbCrLf & vbCrLf & ex.Message, "Error loading file", MessageBoxButtons.OK, MessageBoxIcon.Error)

        End Try

        Return retVal

    End Function
    Public Function Get_OSID_From_Loaded() As String

        Dim retVal As Int32 = 0

        Try

            Dim OSID As String = ""

            Dim OSID_String1 As String = ""
            Dim OSID_String2 As String = ""
            Dim Use_OSID As String = ""
            Dim tmpBinaryValue As String = ""

            Dim CellValue As String = ""
            Dim i As Integer = 0
            Dim c1 As Integer
            Dim c2 As Integer

            For i = 0 To BinaryFile.Length - 1

                tmpBinaryValue = CellValue
                CellValue = Hex(BinaryFile(i))

                If CellValue.Length < 2 Then
                    CellValue = "0" & CellValue
                End If

                tmpBinaryValue += CellValue

                If i > (BinaryFile.Length - 6) And c1 < 3 Then
                    OSID_String1 += CellValue
                    c1 += 1
                End If
                If i > (BinaryFile.Length - 8) And c2 < 3 Then
                    OSID_String2 += CellValue
                    c2 += 1
                End If
            Next

            If tmpBinaryValue = "FFFF" Or tmpBinaryValue = "0000" Then
                retVal = Convert.ToInt32(OSID_String2, 16)
            Else
                retVal = Convert.ToInt32(OSID_String1, 16)
            End If

        Catch ex As Exception

            MessageBox.Show("An error occured loading the binary file." & vbCrLf & vbCrLf & ex.Message, "Error loading file", MessageBoxButtons.OK, MessageBoxIcon.Error)

        End Try

        Return retVal

    End Function
    Public Sub PopulatepubCategoryList()

        pubCategoryCount = 34
        ReDim pubCategoryList(pubCategoryCount, 2)

        'Accessories
        pubCategoryList(0, 0) = "0,1"
        pubCategoryList(0, 1) = "Fans"
        pubCategoryList(1, 0) = "0,2 "
        pubCategoryList(1, 1) = "IAC"
        pubCategoryList(2, 0) = "0,3"
        pubCategoryList(2, 1) = "A/C"
        pubCategoryList(3, 0) = "0,4"
        pubCategoryList(3, 1) = "ALT"
        pubCategoryList(4, 0) = "0,5"
        pubCategoryList(4, 1) = "EGR"

        'Fuel
        pubCategoryList(5, 0) = "1,1"
        pubCategoryList(5, 1) = "Fuel Pump"
        pubCategoryList(6, 0) = "1,2"
        pubCategoryList(6, 1) = "Base Fueling"
        pubCategoryList(7, 0) = "1,3"
        pubCategoryList(7, 1) = "PE"
        pubCategoryList(8, 0) = "1,4"
        pubCategoryList(8, 1) = "MAP"
        pubCategoryList(9, 0) = "1,5"
        pubCategoryList(9, 1) = "MAF"
        pubCategoryList(10, 0) = "1,6"
        pubCategoryList(10, 1) = "Fuel Injector"

        pubCategoryList(11, 0) = "1,7"
        pubCategoryList(11, 1) = "Startup"

        pubCategoryList(12, 0) = "1,8"
        pubCategoryList(12, 1) = "Open Loop & Closed Loop"
        pubCategoryList(13, 0) = "1,9"
        pubCategoryList(13, 1) = "Acceleration Enrichment"
        pubCategoryList(14, 0) = "1,10"
        pubCategoryList(14, 1) = "Deceleration Enleanment"

        'Spark
        pubCategoryList(15, 0) = "2,1"
        pubCategoryList(15, 1) = "Base Timing"
        pubCategoryList(16, 0) = "2,2"
        pubCategoryList(16, 1) = "Knock Sensor"
        pubCategoryList(17, 0) = "2,3"
        pubCategoryList(17, 1) = "Speed/Timing Limiter"
        pubCategoryList(32, 0) = "2,4"
        pubCategoryList(32, 1) = "Decel Modifiers"
        pubCategoryList(33, 0) = "2,5"
        pubCategoryList(33, 1) = "Dwell Modifiers"
        pubCategoryList(34, 0) = "2,6"
        pubCategoryList(34, 1) = "Misfire"


        'Transmission
        pubCategoryList(18, 0) = "3,1"
        pubCategoryList(18, 1) = "Gear Ratio"
        pubCategoryList(19, 0) = "3,2"
        pubCategoryList(19, 1) = "Shift Switch"
        pubCategoryList(20, 0) = "3,3"
        pubCategoryList(20, 1) = "Shift Point - Cruise"
        pubCategoryList(21, 0) = "3,4"
        pubCategoryList(21, 1) = "Shift Point - Hot"
        pubCategoryList(22, 0) = "3,5"
        pubCategoryList(22, 1) = "Shift Point - Normal"
        pubCategoryList(23, 0) = "3,6"
        pubCategoryList(23, 1) = "Shift Point - Performance"
        pubCategoryList(24, 0) = "3,7"
        pubCategoryList(24, 1) = "Shift Point - Urban"
        pubCategoryList(25, 0) = "3,8"
        pubCategoryList(25, 1) = "Shift Time"
        pubCategoryList(26, 0) = "3,9"
        pubCategoryList(26, 1) = "Shift Pressure"
        pubCategoryList(27, 0) = "3,10"
        pubCategoryList(27, 1) = "TCC"

        'Supercharger
        pubCategoryList(28, 0) = "4,1"
        pubCategoryList(28, 1) = "Boost Control"

        'Torque Management
        pubCategoryList(29, 0) = "5,1"
        pubCategoryList(29, 1) = "Fuel"
        pubCategoryList(30, 0) = "5,2"
        pubCategoryList(30, 1) = "Spark"
        pubCategoryList(31, 0) = "5,3"
        pubCategoryList(31, 1) = "Transmission"

    End Sub

    Public Function GetCategory(ByVal tmpString As String, Optional ByVal RequestSubCat As Boolean = False) As Integer

        Dim retval As Integer = 7  'Uncatagorized Node
        If RequestSubCat Then retval = 0

        If RequestSubCat Then
            Dim i As Integer
            Dim tmpFuncString As String = ""
            Dim tmpArray As Array
            For i = 0 To pubCategoryCount
                tmpFuncString = pubCategoryList(i, 1)
                If tmpFuncString = tmpString Then
                    tmpArray = pubCategoryList(i, 0).Split(",")
                    If Not RequestSubCat Then
                        retval = (tmpArray(0))
                    Else
                        retval = Val(tmpArray(1)) - 1
                    End If
                End If
            Next
        Else

            retval = 7
            Select Case tmpString
                'Setup Main Categories
                Case "Accessories"
                    retval = 0
                Case "Fuel"
                    retval = 1
                Case "Spark"
                    retval = 2
                Case "Transmission"
                    retval = 3
                Case "Supercharger"
                    retval = 4
                Case "Torque Managment"
                    retval = 5
                Case "Torque Management"
                    retval = 5
                Case "Diagnostics"
                    retval = 6
            End Select
        End If

        Return retval

    End Function

    Public Function ImportedTableCount() As Integer

        'Verify table count
        Dim i As Integer = 0
        Dim tmpTableCount As Integer = 0

        For i = 1 To TableCount
            If AvailableTables(1, i) <> "" Then tmpTableCount += 1
        Next

        Return tmpTableCount

    End Function

    Public Function UpdateChecksum() As Boolean

        Dim resp As Boolean = False

        Dim counter As Integer
        Dim checksum As Long
        Dim csumstring As String
        Dim SubString As String


        'Get OSID and checksum location from database
        Dim BinaryInfo() As String = GetOSIDDataFromDatabase(Current_OSID)
        Dim osidloc As Integer = Convert.ToInt32(BinaryInfo(2), 16)
        Dim CsumLoc As Integer = Convert.ToInt32(BinaryInfo(1), 16)

        counter = 0
        checksum = 0

        resp = True

        Try
            While counter < BinaryFile.Length

                If counter = &H4000 Then        'skip over nvram area
                    If BinaryFile.Length = 1048576 Then counter = &H10000 Else counter = &H8000
                ElseIf counter = CsumLoc Then   'skip over checksum location
                    counter = CsumLoc + 4
                ElseIf counter = osidloc Then   'skip over osid
                    counter = osidloc + 4
                End If

                checksum = checksum + (Convert.ToInt32(BinaryFile(counter)) * 256) + (Convert.ToInt32(BinaryFile(counter + 1)))
                counter += 2

            End While
        Catch ex As Exception
            MsgBox("Error updating checksum..." & vbCrLf & vbCrLf & ex.Message)
            resp = False
        End Try

        If Not resp = False Then

            Try
                checksum = checksum And &HFFFFFFFF

                If checksum > &HFFFFFFFF Then
                    checksum -= &H100000000
                End If

                csumstring = (Hex(checksum).ToString)
                If csumstring.Length > 8 Then
                    csumstring = csumstring.Substring((csumstring.Length - 8), 8)
                End If

                Dim CsumBytesV6(4) As Byte

                'Checksum Byte0
                SubString = (csumstring(0)) & (csumstring(1))
                CsumBytesV6(0) = Convert.ToByte(Integer.Parse(SubString, Globalization.NumberStyles.HexNumber))
                'Checksum Byte1
                SubString = (csumstring(2)) & (csumstring(3))
                CsumBytesV6(1) = Convert.ToByte(Integer.Parse(SubString, Globalization.NumberStyles.HexNumber))
                'Checksum Byte2
                SubString = (csumstring(4)) & (csumstring(5))
                CsumBytesV6(2) = Convert.ToByte(Integer.Parse(SubString, Globalization.NumberStyles.HexNumber))
                'Checksum Byte3
                SubString = (csumstring(6)) & (csumstring(7))
                CsumBytesV6(3) = Convert.ToByte(Integer.Parse(SubString, Globalization.NumberStyles.HexNumber))

                'Write new checksum to file byte array
                BinaryFile(CsumLoc) = CsumBytesV6(0)
                BinaryFile(CsumLoc + 1) = CsumBytesV6(1)
                BinaryFile(CsumLoc + 2) = CsumBytesV6(2)
                BinaryFile(CsumLoc + 3) = CsumBytesV6(3)

            Catch ex As Exception
                MsgBox("Error updating checksum..." & vbCrLf & vbCrLf & ex.Message)
                resp = False
            End Try

        End If

        Return resp

    End Function
    

    Public Function Save_Binary_File(ByVal NewFile As String) As Boolean

        Dim retVal As Boolean = True

        If UpdateChecksum() Then

            If IO.File.Exists(NewFile) Then
                Try
                    IO.File.Delete(NewFile)
                Catch ex As Exception
                    MessageBox.Show(ex.Message, "Error Saving", MessageBoxButtons.OK, MessageBoxIcon.Error)
                    GoTo Finished
                End Try
            End If

            Dim fs2 As New IO.FileStream(NewFile, IO.FileMode.CreateNew, IO.FileAccess.Write)
            Dim tmpWriter As New IO.BinaryWriter(fs2)

            Try

                Dim i As Integer = 0
                For i = 0 To BinaryFile.Length - 1
                    tmpWriter.Write(BinaryFile(i))
                Next

            Catch ex As Exception
                MessageBox.Show("There was an error saving the new binary file." & vbCrLf & vbCrLf & ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
                retVal = False
            Finally
                tmpWriter.Close()
            End Try

        Else
            MessageBox.Show("There was an error saving the new binary file." & vbCrLf & vbCrLf & "Checksum could not be calculated", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            retVal = False
        End If

Finished:

        Return retVal

    End Function

    Public Function SelectCellColor(ByVal percentvalue As Single) As Color

        If percentvalue < 0 Then percentvalue = percentvalue * -1

        percentvalue = Math.Round(percentvalue, 0)

        Dim tmpColor As Color

        Select Case percentvalue
            Case 0 To 1
                tmpColor = Color.FromArgb(255, 0, 255, 0)
            Case 2 To 5
                tmpColor = Color.FromArgb(255, 128, 255, 0)  '32)
            Case 6 To 9
                tmpColor = Color.FromArgb(255, 128, 255, 128)  '32)
            Case 10 To 13
                tmpColor = Color.FromArgb(255, 228, 240, 140)  '64)
            Case 14 To 18
                tmpColor = Color.FromArgb(255, 248, 224, 114)  '96)
            Case 19 To 22
                tmpColor = Color.FromArgb(255, 255, 255, 0)  '128)
            Case 23 To 27
                tmpColor = Color.FromArgb(255, 255, 196, 0)   '96)
            Case 28 To 38
                tmpColor = Color.FromArgb(255, 255, 128, 0)   '64)
            Case 39 To 49
                tmpColor = Color.FromArgb(255, 255, 64, 0)   '32)
            Case Is > 49
                tmpColor = Color.FromArgb(255, 255, 0, 0)
        End Select

        Return tmpColor

    End Function

    Public Function Import_HPT_Table(ByVal PathToTable As String) As Array


        Dim tmp_Table(20, 85) As String
        Dim HPT_Table() As String

        'Table_Index is the 3rd dim in the Spark_Data array

        Dim TimingTableLoaded As Boolean
        Dim i As Integer    'counter 1
        Dim a As Integer    'counter 2
        Dim tmpString As String 'Multiuse string holder
        Dim tmpArray As Array   'Use to break up the data from the streamreader
        Dim LastOne As Boolean = False
        Dim ArrayLength As Int16 = 0
        Dim LoopCount As Int16 = 0

        Dim StReader As IO.StreamReader

        Try
            StReader = New IO.StreamReader(PathToTable)
        Catch ex As Exception
            MsgBox("Can not import Timing table from:" & vbCrLf & _
                PathToTable & vbCrLf & vbCrLf & ex.Message)
            TimingTableLoaded = False
            GoTo LeaveNow
        End Try

        'Read the first line, this is the header line in the csv file, we don't want or need this line
        tmpString = StReader.ReadLine
        'the next line is the table name, we don't need this either
        tmpString = StReader.ReadLine
        'Next is a blank line...
        tmpString = StReader.ReadLine

        Try
            Do
                'read the line from the High Octane Spark table csv file
                tmpString = StReader.ReadLine
                If tmpString = Nothing Then
                    Exit Do
                End If

                'Split the table fields seperated with commas
                tmpArray = tmpString.Split(Chr(9))
                ArrayLength = tmpArray.Length
                'Enter the data to the array
                For a = 0 To ArrayLength - 1
                    tmp_Table(LoopCount, a) = tmpArray(a)
                Next
                If LastOne Then Exit Do
                If Not tmpString = "" Then LoopCount += 1

            Loop While tmpString <> ""

            'Now, make the 2 dimention array (a 2D table) a 1 dim array 
            ReDim HPT_Table(ArrayLength - 1)
            For a = 0 To ArrayLength - 1
                tmpString = ""
                For i = 0 To LoopCount - 1
                    tmpString += tmp_Table(i, a) & ","
                Next
                tmpString = tmpString.Remove(tmpString.Length - 1, 1)
                HPT_Table(a) = tmpString
            Next

            TimingTableLoaded = True

        Catch ex As Exception
            MsgBox("There was an error importing the Timing table from:" & vbCrLf & _
                    PathToTable & vbCrLf & vbCrLf & ex.Message)
            TimingTableLoaded = False
        End Try

        StReader.Close()

LeaveNow:

        Return HPT_Table

    End Function

    Function Import_HPT_MAFTable(ByVal PathToTable As String) As Array

        Dim MAFTableImported As Boolean
        Dim i As Integer    'counter
        Dim tmpString As String 'Multiuse string holder
        Dim tmpArray As Array   'Use to break up the data from the streamreader

        Dim MAFTable() As Array

        Dim StReader As IO.StreamReader

        Try
            StReader = New IO.StreamReader(PathToTable)
        Catch ex As Exception
            MsgBox("Can not import MAF table from:" & vbCrLf & _
                PathToTable & vbCrLf & vbCrLf & ex.Message)
            MAFTableImported = False
            Exit Function
        End Try

        'Read the first line, this is the vehicle ID line we don't want or need this line
        tmpString = StReader.ReadLine

        'Verify we are looking at the exported MAF table...
        tmpString = StReader.ReadLine
        If Not tmpString = "" Then
            If tmpString = "MAF Airflow vs. Output Frequency" Then

                tmpString = StReader.ReadLine
                If tmpString = "" Then tmpString = StReader.ReadLine
                If tmpString = "" Then tmpString = StReader.ReadLine

                Try

                    'Split the fields seperated by a TAB

                    tmpArray = tmpString.Split(Chr(9))

                    'Get the first field, we'll need to format this before 
                    'saving it to the MAFTable array 
                    'tmpString = tmpArray(0)

                    For i = 0 To UBound(tmpArray)  '80
                        'This is the actual MAF value from the imported file
                        MAFTable(i) = tmpArray(i)
                    Next

                    MAFTableImported = True

                Catch ex As Exception
                    MsgBox("There was an error importing the MAF table from:" & vbCrLf & _
                        PathToTable & vbCrLf & vbCrLf & ex.Message)
                    MAFTableImported = False

                End Try
            End If
        End If



        StReader.Close()

        Return MAFTable

    End Function

    
End Module
